
PKG:=dropbear
VERSION:=0.49
DIR:=${PKG}-${VERSION}

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile
	${MAKE} -C ${DIR} 

.PHONY: install
install:
	cp ${DIR}/dbclient ${ROOT}/usr/local/bin/.
	cp ${DIR}/dropbearconvert ${ROOT}/usr/local/bin/.
	cp ${DIR}/dropbearkey ${ROOT}/usr/local/bin/.
	cp ${DIR}/dropbear ${ROOT}/usr/local/sbin/.

${DIR}/Makefile:
	cd ${DIR} &&  ./configure CFLAGS="${CFLAGS}" LDFLAGS="${TOOLCHAIN_ABI}" --host=mips --disable-zlib

${DIR}:
	tar -zxf ${STORAGE}/${PKG}/${PKG}-${VERSION}.tar.gz
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/100-pubkey_path.patch
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/110-change_user.patch
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/120-hostkey_prompt.patch
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/130-ssh_ignore_o_and_x_args.patch
	#cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/140-use_dev_urandom.patch
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/150-dbconvert_standalone.patch
	cd ${DIR}  patch -p0 < ${STORAGE}/${PKG}/160-tty_close.patch
	cd ${DIR} && sed -i 's/#include <utmpx.h>//g' includes.h
	cd ${DIR} && sed -i 's:dev\/random:dev\/urandom:g' options.h

