PKG:=net-snmp
VERSION:=5.4
DIR:=${PKG}-${VERSION}
WN302T_DIR=Wn302T

-include ../.config

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile ${WN302T_DIR}
	cd ${DIR} && ${MAKE}
ifeq ($(CONFIG_configd), y)
	cd ${WN302T_DIR} && ${MAKE}
endif

.PHONY: install
install:
	cd ${DIR} && ${MAKE} install
ifeq ($(CONFIG_configd), y)
	cp ${WN302T_DIR}/wn302t.so ${ROOT}/usr/local/lib/snmp/dlmod/
endif

${DIR}/Makefile:
	cd ${DIR} && ./configure --with-cc=mips64-octeon-linux-gnu-gcc --with-linkcc=mips64-octeon-linux-gnu-gcc --with-cflags=-mabi=64 --with-ld=mips64-octeon-linux-gnu-gcc --with-ldflags="-mabi=64 -lpthread" --enable-mini-agent --disable-mib-loading --without-openssl --without-kmem-usage --with-mib-modules="ucd-snmp/dlmod ucd-snmp/pass mibII" --disable-manuals --disable-des --disable-privacy --disable-md5 --disable-perl --without-perl-modules --disable-scripts --with-default-snmp-version="2" --with-out-security-modules="ksm" --disable-embedded-perl --disable-perl-cc-checks --disable-ipv6 --with-ar=mips64-octeon-linux-gnu-ar --host=mips64-octeon-linux-gnu --target=mips64-octeon-linux-gnu --build=i386-redhat-linux-gnu --prefix=${ROOT}/usr/local --enable-mib-config-checking --with-PACKAGE=Net-SNMP --with-endianness=big --with-enterprise-oid=4526 --with-enterprise-sysoid=.1.3.6.1.4.1.4526.100.7.4 --with-out-transports="TCP UDPIPv6 TCPIPv6 Unix Callback AAL5PVC IPX" --with-defaults --with-out-mib-modules="snmpv3mibs agentx agent_mibs disman/event disman/schedule utilities host examples/ucdDemoPublic examples/example mibII/mta_sendmail disman/old-event-mib ucd-snmp/lmSensors" --with-enterprise-notification-oid=.1.3.6.1.4.1.4526.100.7.4.17

${DIR}:
	tar -zxf ${STORAGE}/${PKG}/${PKG}-${VERSION}.tar.gz
	cd ${DIR} &&  cp ../../../../tools/mips64-octeon-linux-gnu/sys-root/usr/include/fstab.h include/net-snmp/library/.
	cd ${DIR} && sed -i 's/<fstab.h>/"net-snmp\/library\/fstab.h"/g' agent/mibgroup/ucd-snmp/disk.c
	cd ${DIR} && sed -i 's/<fstab.h>/"net-snmp\/library\/fstab.h"/g' agent/mibgroup/ucd-snmp/errormib.c
	cd ${DIR} && sed -i 's/<fstab.h>/net-snmp\/library\/fstab.h/g' agent/mibgroup/ucd-snmp/extensible.c
	cd ${DIR} && sed -i 's/<fstab.h>/"net-snmp\/library\/fstab.h"/g' agent/mibgroup/ucd-snmp/loadave.c
	cd ${DIR} && sed -i 's/<fstab.h>/"net-snmp\/library\/fstab.h"/g' agent/mibgroup/ucd-snmp/vmstat_linux.c
	cd ${DIR}/../ && patch -p0 < ${STORAGE}/${PKG}/net-snmp.patch
	cd ${DIR}/agent/mibgroup/       && cp -r ${STORAGE}/${PKG}/Bridge .
	cd ${DIR}/agent/mibgroup/       && cp -r ${STORAGE}/${PKG}/wireless .
	cd ${DIR}/agent/mibgroup/       && cp -r ${STORAGE}/${PKG}/Trap_mod .
	

${WN302T_DIR}:
ifeq ($(CONFIG_configd), y)
	cp -dpR ${STORAGE}/${PKG}/${WN302T_DIR} .
endif

