include ../.config
ifdef TOOLCHAIN_ABI_N32
   SSL_TARGET=linux-octeon32
endif
ifdef TOOLCHAIN_ABI_64
   SSL_TARGET=linux-octeon64
endif

ifdef TOOLCHAIN_UCLIBC
   SSL_TARGET=linux-octeon64
endif


PKG:=openssl
VERSION:=0.9.7i
DIR:=${PKG}-${VERSION}

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile.bak
	${MAKE} -C ${DIR} AR="${AR} -r" 

${DIR}/Makefile.bak:

	cd ${DIR} && ./Configure linux-mips64 --openssldir=/etc --prefix=${ROOT}  
	cd ${DIR} && sed -i 's/AR=ar $(ARFLAGS) r/AR=mips64-octeon-linux-gnu-ar r/g' Makefile

	cd ${DIR} && sed -i 's:RANLIB= /usr/bin/ranlib:RANLIB=mips64-octeon-linux-gnu-ranlib:g' Makefile


.PHONY: install
install: ${DIR}
	#${MAKE} -C ${DIR} INSTALL_PREFIX=${ROOT} install
	cp ${DIR}/libssl.a ${ROOT}/usr/lib/.
	cp ${DIR}/libcrypto.a ${ROOT}/usr/lib/.

${DIR}:
	tar -zxf ${STORAGE}/${PKG}/${PKG}-${VERSION}.tar.gz
	ln -s ${DIR} ${PKG}
	cd ${DIR} && patch -Np1 -i ${STORAGE}/${PKG}/openssl-0.9.7i-allow_lib64-1.patch
	cd ${DIR} && patch -Np1 -i ${STORAGE}/${PKG}/openssl-0.9.7i-mips_support-1.patch

	cd ${DIR} && sed -i 's/gcc:-mabi=64 -DB_ENDIAN/mips64-octeon-linux-gnu-gcc:-mabi=64 -DB_ENDIAN/g' Configure


