PKG:=oprofile
VERSION:=0.9.2
DIR:=${PKG}-${VERSION}

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile
	${MAKE} -C ${DIR}

${DIR}/Makefile:
	cd ${DIR} &&  ./configure --prefix=/usr --host=${CROSS} \
		--with-kernel-support \
		--with-extra-includes=${ROOT}/usr/include \
		CFLAGS="-mabi=64 -Os -fomit-frame-pointer -Wl,-L${ROOT}/usr/lib64" \
		CXXFLAGS="-mabi=64 -Os -fomit-frame-pointer -Wl,-L${ROOT}/usr/lib64" LDFLAGS="-mabi=64"

.PHONY: install
install:
	${MAKE} -C ${DIR} prefix=${ROOT}/usr install

${DIR}:
	tar -zxf ${STORAGE}/${PKG}-${VERSION}.tar.gz
	cd ${DIR} && patch -s -p1 < ${STORAGE}/${PKG}-${VERSION}-octeon.patch
	
