
PKG:=php
VERSION:=5.2.3
DIR:=${PKG}-${VERSION}

-include ../.config

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile
	cd ${DIR} && ${MAKE}

.PHONY: install
install:
	cd ${DIR} && ${MAKE} install
ifeq ($(CONFIG_configd), y)
	rm ${ROOT}/usr/local/bin/mips64-octeon-linux-gnu-php
	rm ${ROOT}/usr/local/bin/mips64-octeon-linux-gnu-php-config
	rm ${ROOT}/usr/local/bin/mips64-octeon-linux-gnu-phpize
	mv ${ROOT}/usr/local/bin/mips64-octeon-linux-gnu-php-cgi ${ROOT}/usr/local/bin/php
endif
	
${DIR}/Makefile:
	cd ${DIR} && ./buildconf --force
	cd ${DIR}&&  CC=mips64-octeon-linux-gnu-gcc CFLAGS="${CFLAGS}" LD=mips64-octeon-linux-gnu-gcc LDFLAGS="${TOOLCHAIN_ABI}" AR=mips64-octeon-linux-gnu-ar ./configure --host=mips64-octeon-linux-gnu --target=mips64-octeon-linux-gnu --build=i386-redhat-linux-gnu --prefix=${ROOT}/usr/local --enable-c_ext --without-iconv --disable-bcmath --disable-calendar --disable-dba --disable-dbase --disable-exif --disable-ftp --disable-gd-native-ttf --disable-gd-jis-conv --disable-mbstring --enable-mbregex --enable-posix --disable-reflection --enable-session --enable-ucd-snmp-hack --disable-soap --disable-sqlite-utf8 --disable-wddx --disable-zip --disable-xml --disable-xmlreader --disable-xmlwriter --disable-pdo --without-pdo-sqlite --disable-sockets --disable-filter --disable-simplexml --disable-sysvmsg --disable-sysvsem --disable-sysvshm --disable-tokenizer  --disable-ctype --without-sqlite --disable-shmop --disable-pcntl --disable-libxml --disable-dom --disable-hash --disable-spl --without-pear --disable-posix --disable-json 
ifeq ($(CONFIG_configd), y)
	cd ${DIR} && sed -i 's:INCLUDES = :INCLUDES = -I\${NMS_DIR}/include -I\${NMS_DIR}/configd/libs/lu -I\${NMS_DIR}/configd/libs/lc :g' Makefile
	cd ${DIR} && sed -i 's,INCLUDE_PATH = ,INCLUDE_PATH = \${NMS_INCLUDE}/:\${NMS_DIR}/configd/:,g' Makefile
	cd ${DIR} && sed -i 's:PHP_GLOBAL_OBJS = :PHP_GLOBAL_OBJS = \${NMS_DIR}/lib/libconfdapi.a \${NMS_DIR}/lib/libdevutils.a :g' Makefile
endif
	cd ${DIR}/main && sed -i '/PHP_INI_ENTRY("max_execution_time"/ c PHP_INI_ENTRY("max_execution_time","90",PHP_INI_ALL,OnUpdateTimeout)\n' main.c
	cd ${DIR}/main && sed -i '/STD_PHP_INI_ENTRY("post_max_size"/ c STD_PHP_INI_ENTRY("post_max_size","25M",PHP_INI_SYSTEM|PHP_INI_PERDIR,OnUpdateLong,post_max_size,sapi_globals_struct,sapi_globals)\n' main.c
	cd ${DIR}/main && sed -i '/STD_PHP_INI_ENTRY("upload_max_filesize"/ c STD_PHP_INI_ENTRY("upload_max_filesize","20M",PHP_INI_SYSTEM|PHP_INI_PERDIR,OnUpdateLong,upload_max_filesize,php_core_globals,core_globals)\n' main.c

${DIR}:
	tar -jxf ${STORAGE}/${PKG}/${PKG}-${VERSION}.tar.bz2
ifeq ($(CONFIG_configd), y)
	cp -r ${STORAGE}/${PKG}/c_ext ${DIR}/ext/.
endif



