#
# This makefile is for building wireless-tools on Cavium platform
# This will in turn executes actual Makefile of wireless tools.
#
# NOTE: The makefiles (*.mk) in pkg_makefiles are executed by make
# from embedded_rootfs/build directory. Any files/directory created
# or modified are relative to this directory.
#
# Steps involved in building the package
# 1. Extract and create package directory from package tar ball.
#    A package directory is created under embedded_rootfs/build directory.
# 2. Apply any required patches source and Makefile
# 3. Execute actual Makefile of the package
# 
PKG:=wireless_tools
VERSION:=28
DIR:=${PKG}.${VERSION}

#
# Default target is all which will build the package and installs
#
.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile
	${MAKE} -C ${DIR} CFLAGS="${CFLAGS}"

${DIR}/Makefile:
	cd ${DIR} && ./configure --prefix=${ROOT}/usr --host=${CROSS} --with-linux-headers=${KERNEL_DIR}/include CFLAGS="${CFLAGS}" LDFLAGS=${TOOLCHAIN_ABI}

.PHONY: install
install: ${DIR}
	${MAKE} -C ${DIR} PREFIX="${ROOT}" install

#
# - Create build directory with package source files
# - Apply any required modification and patches
#
${DIR}:
	tar -zxf ${STORAGE}/${PKG}-${VERSION}/${PKG}.${VERSION}.tar.gz
	cp -f ${STORAGE}/${PKG}-${VERSION}/Makefile ${DIR}
