#
# This makefile is for installing WLAN driver modules and 
# Arada WLAN tools
#
# NOTE: The makefiles (*.mk) in pkg_makefiles are executed by make
# from embedded_rootfs/build directory. Any files/directory created
# or modified are relative to this directory.
#
# Steps involved in installing WLAN modules

# 1. Create embedded_rootfs/build/wlan directory & extract WLAN module files
#    into this directory
# 2. Copy WLAN kernel modules to /lib/modules/wlan directory of rootfs
# 2. Copy WLAN tool programs to /usr/local/bin directory of rootfs
# 
PKG:=wlan
VERSION:=1.0
DIR:=${PKG}

.PHONY: all
all: install

.PHONY: install
install: 
	tar -xvzf ${WLAN_DIR}/${PKG}.tgz
	mkdir -p ${ROOT}/lib/modules/wlan
	mkdir -p ${ROOT}/usr/local/bin
	cp ${PKG}/*.ko ${ROOT}/lib/modules/wlan
	cp ${PKG}/wlanconfig ${ROOT}/usr/local/bin
	cp ${PKG}/athdebug ${ROOT}/usr/local/bin
	cp ${PKG}/80211debug ${ROOT}/usr/local/bin
	cp ${PKG}/hostapd ${ROOT}/usr/local/bin
	cp ${PKG}/hostapd.conf ${ROOT}/etc
	cp ${PKG}/wpa_supplicant ${ROOT}/usr/local/bin
	cp ${PKG}/wpa_supplicant.conf ${ROOT}/etc
	cp ${PKG}/sc_stats ${ROOT}/usr/local/bin
	cp ${PKG}/libsc.so ${ROOT}/usr/lib64
