#!/bin/sh

assert_good ()
{
   if [ $? -ne 0 ]; then exit 255;fi
}

assert_bad ()
{
   if [ $? -eq 0 ]; then exit 255;fi
}

assert ()
{
   "$@"
   assert_good
}

require_good ()
{
   if [ $? -ne 0 ]; then exit 254;fi
}

require_bad ()
{
   if [ $? -eq 0 ]; then exit 254;fi
}

require ()
{
   "$@"
   require_good
}

unimplemented ()
{
   exit 253
}

pass_if_not()
{
   if ! "$@"; then exit 0;fi
}

get_num_cores()
{
   grep processor /proc/cpuinfo | wc -l
}

have_cn30xx()
{
   grep -q "Octeon CN30" /proc/cpuinfo
}

have_cavium_pci_device()
{
   grep -q "PCI device 177d:" /proc/pci
   [ $? -ne 1 ]
}
