/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "basicSettings.h"

lan_Settings node,node_set;
int flags = 0;
char req_name[255],str[255];
char ver_name[50] = {0};

int rv;
long eval_sysCoReg(long);
/*function for validating AP Name*/
long isAlphaNumeric(u_char*);

/*extern function for validating IP Address*/
extern long isValidIP(u_char*);
extern long check_ZeroIP(u_char*);
long eval_RegionInfo(long);
/*
 * basicSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             basicSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 1 };

/*
 * variable4 basicSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the basicSettings mib section 
 */

struct variable4 basicSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define APNAME		1
    {APNAME, ASN_OCTET_STR, RWRITE, var_basicSettings, 1, {1}},
#define SYSMACADDRESS		2
    {SYSMACADDRESS, ASN_OCTET_STR, RONLY, var_basicSettings, 1, {2}},
#define SYSVERSION		3
    {SYSVERSION, ASN_OCTET_STR, RONLY, var_basicSettings, 1, {3}},
#define SYSCOUNTRYREGION		4
    {SYSCOUNTRYREGION, ASN_INTEGER, RWRITE, var_basicSettings, 1, {4}},
#define ADMINPASSWD		5
    {ADMINPASSWD, ASN_OCTET_STR, RWRITE, var_basicSettings, 1, {5}},
#define DHCPCLIENTSTATUS	6
    {DHCPCLIENTSTATUS, ASN_INTEGER, RWRITE, var_basicSettings, 1, {6}},
#define IPADDR		7
    {IPADDR, ASN_IPADDRESS, RWRITE, var_basicSettings, 1, {7}},
#define NETMASKADDR	8
    {NETMASKADDR, ASN_IPADDRESS, RWRITE, var_basicSettings, 1, {8}},
#define GATEWAYADDR	9
    {GATEWAYADDR, ASN_IPADDRESS, RWRITE, var_basicSettings, 1, {9}},
#define PRIDNSIPADDR	10
    {PRIDNSIPADDR, ASN_IPADDRESS, RWRITE, var_basicSettings, 1, {10}},
#define SNDDNSIPADDR	11
    {SNDDNSIPADDR, ASN_IPADDRESS, RWRITE, var_basicSettings, 1, {11}},
#define SPANTREESTATUS	12
    {SPANTREESTATUS, ASN_INTEGER, RWRITE, var_basicSettings, 1, {12}},
#define MANAGEMENTVLANID	13
    {MANAGEMENTVLANID, ASN_INTEGER, RWRITE, var_basicSettings, 1, {13}},
#define UNTAGGEDVLANSTATUS	14
    {UNTAGGEDVLANSTATUS, ASN_INTEGER, RWRITE, var_basicSettings, 1, {14}},
#define UNTAGGEDVLANID		15
    {UNTAGGEDVLANID, ASN_INTEGER, RWRITE, var_basicSettings, 1, {15}},

};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the basicSettings module */
void
init_basicSettings(void)
{
	
    DEBUGMSGTL(("basicSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("basicSettings", basicSettings_variables, variable4,
                 basicSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	printf("\nINIT :BS\n");
}


/*
 * var_basicSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_basicSettings(struct variable *vp,
                oid * name,
                size_t *length,
                int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;
    char ret_buf[255];
    char sys_mac[50];
    int i = 0;
    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;


	sprintf(req_name,"system:basicSettings:");

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case APNAME:
        *write_method = write_apName;

	if(! db_get(req_name,"apName",ret_buf))
        	strcpy(node.apName,ret_buf);
        else return NULL;

	*var_len = strlen(node.apName);
        return (u_char *) node.apName;
    case SYSMACADDRESS:
             strcpy(sys_mac,"system:monitor:"); 
	if(! db_get(sys_mac,"macAddress",ret_buf)) {
		rv = get_mac_addr(node.sysMacAddress,ret_buf);
		if(rv) return NULL;
	}
        else return NULL;
	
	*var_len = 6 ;
        return (u_char *)&node.sysMacAddress;
    case SYSVERSION:
          strcpy(ver_name,"system:monitor:");
	if(! db_get(ver_name,"sysVersion",ret_buf))
	        strcpy(node.sysVersion,ret_buf);
	else return NULL;

	*var_len = strlen(node.sysVersion);
        return (u_char *) node.sysVersion;
    case SYSCOUNTRYREGION:
        *write_method = write_sysCountryRegion;
	 
	if(! db_get(req_name,"sysCountryRegion",ret_buf))
                node.sysCountryRegion = atoi(ret_buf);
        else return NULL;
	
	*var_len = sizeof(unsigned int);
        return (u_char *) &node.sysCountryRegion;
    case ADMINPASSWD:
	*write_method = write_adminPasswd;

	if(! db_get(req_name,"adminPasswd",ret_buf)) {
		 for(i=0;i<strlen(ret_buf);i++)
                    node.adminPasswd[i] = '*';
                 node.adminPasswd[++i] = '\0';
        }
	else return NULL;

	*var_len = strlen(node.adminPasswd);
        return (u_char *) node.adminPasswd;
    case DHCPCLIENTSTATUS:
	*write_method = write_dhcpClientStatus;
	if(! db_get(req_name,"dhcpClientStatus",ret_buf))
		node.dhcpCliStat = atoi(ret_buf);
	else return NULL;

	*var_len = sizeof(int);
        return (u_char *) & node.dhcpCliStat;
        
    case IPADDR:
        *write_method = write_ipAddr;
         {
          char req_buff[100] = {0};
          strcpy(req_buff,"system:monitor:");
          if(! db_get(req_buff,"ipAddress",ret_buf)) {
               rv = get_addr(node.ipAddr,ret_buf);
               //snmp_log(LOG_ERR,"\n ipaddress = \n%s",ret_buf);
                 if( rv ) return NULL;
               }
          else return NULL;
         }
        // snmp_log(LOG_ERR,"\n last value \n %s",node.ipAddr);
	*var_len = 4 ;
        return (u_char *) & node.ipAddr;
    case NETMASKADDR:
        *write_method = write_netmaskAddr;
         {
          char req_buff[100] = {0};
          strcpy(req_buff,"system:monitor:");
          if(! db_get(req_buff,"subNetMask",ret_buf)) {
                 rv = get_addr(node.netmaskAddr,ret_buf);
                 //snmp_log(LOG_ERR,"\n netmask address = \n%s",ret_buf);
                   if( rv ) return NULL;
               }
         else return NULL;
         } 
	*var_len = 4 ;
        return (u_char *) & node.netmaskAddr;
    case GATEWAYADDR:
        *write_method = write_gatewayAddr;
         {
          char req_buff[100] = {0};
          strcpy(req_buff,"system:monitor:");
          if(! db_get(req_buff,"defaultGateway",ret_buf)) {
                  rv = get_addr(node.gatewayAddr,ret_buf);
                  //snmp_log(LOG_ERR,"\n gatewayAddr = \n%s",ret_buf);
                  if( rv ) return NULL;
               }
         else return NULL;
         }
	*var_len = 4 ;
        return (u_char *) & node.gatewayAddr;
    case PRIDNSIPADDR:
        *write_method = write_pridnsipAddr;
         {
          char req_buff[100] = {0};
          strcpy(req_buff,"system:monitor:");
          if(! db_get(req_buff,"primaryDNS",ret_buf)) {
                  rv = get_addr(node.pridnsipAddr,ret_buf);
                  //snmp_log(LOG_ERR,"\n pridnsipAddr = \n%s",ret_buf);
                  if( rv ) return NULL;
               }
         else return NULL;
         }
	*var_len = 4 ;
        return (u_char *) & node.pridnsipAddr;
    case SNDDNSIPADDR:
        *write_method = write_snddnsipAddr;
         {
          char req_buff[100] = {0};
          strcpy(req_buff,"system:monitor:");
          if(! db_get(req_buff,"secondaryDNS",ret_buf)) {
                   rv = get_addr(node.snddnsipAddr,ret_buf);
                   //snmp_log(LOG_ERR,"\n snddnsipAddr = \n%s",ret_buf);
                   if( rv ) return NULL;
                 }
         else return NULL;
         }
	*var_len = 4 ;
        return (u_char *) & node.snddnsipAddr;
    case SPANTREESTATUS:
        *write_method = write_spantreeStatus;
	if(! db_get(req_name,"spanTreeStatus",ret_buf))
		node.spantreeStat = atoi(ret_buf);
	else return NULL;

	*var_len = sizeof(unsigned int);
        return (u_char *) & node.spantreeStat;
    case MANAGEMENTVLANID:
        *write_method = write_managementVlanID;
	if(! db_get(req_name,"managementVlanID",ret_buf))
		node.managementVlanID = atoi(ret_buf);
	else return NULL;

	*var_len = sizeof(unsigned int);
        return (u_char *) & node.managementVlanID;

    case UNTAGGEDVLANSTATUS:
        *write_method = write_untaggedVlanStatus;
        if(! db_get(req_name,"untaggedVlanStatus",ret_buf))
                node.untaggedVlanStat = atoi(ret_buf);
        else return NULL;

        *var_len = sizeof(unsigned int);
        return (u_char *) & node.untaggedVlanStat;

    case UNTAGGEDVLANID:
        *write_method = write_untaggedVlanID;
	if(! db_get(req_name,"untaggedVlanID",ret_buf))
		node.untaggedVlanID = atoi(ret_buf);
	else return NULL;

	*var_len = sizeof(unsigned int);
        return (u_char *) & node.untaggedVlanID;
    default:
        ERROR_MSG("");
    }
    return NULL;
}





int
write_apName(int action,
             u_char * var_val,
             u_char var_val_type,
             size_t var_val_len,
             u_char * statP, oid * name, size_t name_len)
{
    char            *value;
    int             size;
    char val[255] = {0};
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to basicSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if((var_val_len < 1) || (var_val_len > 15)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isAlphaNumeric(var_val)) {
            fprintf(stderr, "write to basicSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = (char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:apName");
	memcpy(val,var_val,var_val_len);
	val[var_val_len] = '\0';
	rv = db_set(req_name,val);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.apName)); 
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_adminPasswd(int action,
             u_char * var_val,
             u_char var_val_type,
             size_t var_val_len,
             u_char * statP, oid * name, size_t name_len)
{
    char            *value;
    int             size;
    char val_pwd[35] = {0};
    memcpy(val_pwd,var_val,var_val_len);
    val_pwd[var_val_len] = '\0';

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to basicSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 32)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
 	if ((strchr(val_pwd, '"')) || (strchr(val_pwd, ' ')) || (strchr(val_pwd, '\'')) )  {
            fprintf(stderr, "write to basicSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = (char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        strcpy(req_name,"system:basicSettings:adminPasswd");
        rv = db_set(req_name,val_pwd);
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        rv = db_set(req_name,(char *)&(node.adminPasswd));
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
        {
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_sysCountryRegion(int action,
                       u_char * var_val,
                       u_char var_val_type,
                       size_t var_val_len,
                       u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(eval_RegionInfo(*(long*)var_val)) {
                fprintf(stderr, "write to basicSettings: bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
	if(eval_sysCoReg(*(long*)var_val)) {
		fprintf(stderr, "write to basicSettings: bad value\n");
		return SNMP_ERR_WRONGVALUE;
	}
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	{
	   /*setting the wlan parameters when country region is changed.*/
           
	   char region_wlan[1500] = {0};
           char ret_val[5] = {0};
           char val[10] = {0};
           char widthInfo[50] = {0};
           char ret_chan[10] = {0};

           sprintf(val,"%lu",*(long*)var_val);
  	  
           strcpy(widthInfo,"system:monitor:40MhzSupport:wlan1:");
           strcat(widthInfo,val);
           snmp_log(LOG_ERR,"widthInfo = %s",widthInfo);
           rv = get_one(widthInfo,ret_chan);
           if(rv)
             return SNMP_ERR_GENERR;
            
	   strcpy(req_name,"system:basicSettings:sysCountryRegion");
           /* get the value of country region from database */
           rv = get_one(req_name,ret_val);
           if(rv)
             return SNMP_ERR_GENERR;
              
	   if(!strcmp(val,ret_val)) 
		return 0;            
           else {
                  strcpy(region_wlan,req_name);
                  strcat(region_wlan," ");
                  strcat(region_wlan,val);
		  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:apMode ");
                  strcat(region_wlan,"0");
              	  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:operateMode ");
                  strcat(region_wlan,"2");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:channel ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:dataRate ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:preambleType ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:txPower ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:mcsRate ");
                  strcat(region_wlan,"99");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:guardInterval ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:channelWidth ");
                  strcat(region_wlan,"0");
    		  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan0:radioStatus ");
                  strcat(region_wlan,"1");   

 		  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:apMode ");
                  strcat(region_wlan,"0");
		  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:operateMode ");
                  strcat(region_wlan,"4");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:channel ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:dataRate ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:preambleType ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:txPower ");
                  strcat(region_wlan,"0");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:mcsRate ");
                  strcat(region_wlan,"99");
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:guardInterval ");
                  strcat(region_wlan,"0");
	 
                  if(!strcmp(ret_chan,"yes")) 
                     strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:channelWidth 2");
                  else 
                     strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:channelWidth 0"); 
               
                  strcat(region_wlan,"\nsystem:wlanSettings:wlanSettingTable:wlan1:radioStatus ");
	          strcat(region_wlan,"0");
                  //snmp_log(LOG_ERR,"region_wlan %s",region_wlan);
                  rv = set_buffer(region_wlan);
                 if(rv)
                   {
                  //snmp_log(LOG_ERR,"returning generic error");
                   return SNMP_ERR_GENERR;
                  }
  
	    }
	    //	snmp_log(LOG_ERR,"rebooting the system");
	    //system("reboot -d 10");	
           }
        break;
	
    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        system("reboot");
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpClientStatus(int action,
                 u_char * var_val,
                 u_char var_val_type,
                 size_t var_val_len,
                 u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val != 0 && *(long*)var_val != 1) {
            fprintf(stderr, "write to basicSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:dhcpClientStatus");
	sprintf(str,"%ld",*(long*)var_val);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_ipAddr(int action,
             u_char * var_val,
             u_char var_val_type,
             size_t var_val_len,
             u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;
    char            str1[50];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to basicSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(check_ZeroIP(var_val))  {
            fprintf(stderr, "write to basicSettings: zero IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to basicSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:ipAddr");
	sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);
        //snmp_log(LOG_ERR,"\n ipaddress value is = \n%s",str);
        //snmp_log(LOG_ERR,"\n req_name is = \n%s",req_name);	
	rv = db_set(req_name,str);
	if(rv)
        {
                //snmp_log(LOG_ERR,"\n db_set fails = \n%d",rv);
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.ipAddr[0],node.ipAddr[1],node.ipAddr[2],node.ipAddr[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_netmaskAddr(int action,
                  u_char * var_val,
                  u_char var_val_type,
                  size_t var_val_len,
                  u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to basicSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:netmaskAddr");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.netmaskAddr[0],node.netmaskAddr[1],node.netmaskAddr[2],node.netmaskAddr[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_gatewayAddr(int action,
                  u_char * var_val,
                  u_char var_val_type,
                  size_t var_val_len,
                  u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to basicSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to basicSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:gatewayAddr");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.gatewayAddr[0],node.gatewayAddr[1],node.gatewayAddr[2],node.gatewayAddr[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_pridnsipAddr(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to basicSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to basicSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }

        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:priDnsAddr");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        sprintf(str,"%d.%d.%d.%d",node.pridnsipAddr[0],node.pridnsipAddr[1],node.pridnsipAddr[2],node.pridnsipAddr[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snddnsipAddr(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to basicSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to basicSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:sndDnsAddr");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        sprintf(str,"%d.%d.%d.%d",node.snddnsipAddr[0],node.snddnsipAddr[1],node.snddnsipAddr[2],node.snddnsipAddr[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_spantreeStatus(int action,
               u_char * var_val,
               u_char var_val_type,
               size_t var_val_len,
               u_char * statP, oid * name, size_t name_len)
{
	

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if( *(long*)var_val != 0 && *(long*)var_val != 1) {
		fprintf(stderr, "write to basicSettings: bad Value\n");
		return SNMP_ERR_WRONGVALUE;
	}
        break;

    case RESERVE2:
        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:spanTreeStatus");
	sprintf(str,"%lu",*(long*)var_val);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.spantreeStat));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_managementVlanID(int action,
                       u_char * var_val,
                       u_char var_val_type,
                       size_t var_val_len,
                       u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val > 4094 || *(long*)var_val < 1) {
            fprintf(stderr, "write to basicSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:managementVlanID");
	sprintf(str,"%lu",*(long*)var_val);
	rv = 0;	
	rv = db_set(req_name,str);
	if(rv)
        {
		//printf("\n\n db_set :FAILED %d \n\n",rv);
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.managementVlanID));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	rv = db_save();
	if( rv ){
		printf("\n\n db_save : FAILED \n\n");
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_untaggedVlanStatus(int action,
                     	u_char * var_val,
                     	u_char var_val_type,
			size_t var_val_len,
                     	u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if (*(long*)var_val != 0 && *(long*)var_val != 1) {
            fprintf(stderr, "write to basicSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;
    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        strcpy(req_name,"system:basicSettings:untaggedVlanStatus");
        sprintf(str,"%lu",*(long*)var_val);
        rv = db_set(req_name,str);
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;
	case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        rv = db_set(req_name,(char *)&(node.untaggedVlanStat));
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_untaggedVlanID(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to basicSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to basicSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val > 4094 || *(long*)var_val < 1) {
            fprintf(stderr, "write to basicSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	strcpy(req_name,"system:basicSettings:untaggedVlanID");
	sprintf(str,"%lu",*(long*)var_val);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.untaggedVlanID));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() )
	{
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


long eval_sysCoReg(long val)
{
	switch(val) {
		case 840:
		case   8:
		case  51:
		case  32:
		case  40:	
		case  36:
		case  31:	
		case  56:
		case 100:
		case  48:
		case  96:
		case  68:
		case  76:
		case 112: 
		case  84:
		case 124: 
		case 756:
		case 152:
		case 156:
		case 170:
		case 188:
		case 196:
		case 203:
		case 276:
		case 208:
		case 214:
		case  12:
		case 218:
		case 233:
		case 818:
		case 724:
		case 246:
		case 250:
		case 826:
		case 268:
		case 300:
		case 320:
		case 344:
		case 340:
		case 191:
		case 348:
		case 360:
		case 372:
		case 376:
		case 356:
		case 364:
                case 352:
                case 380:
                case 400:
                case 392:
                case 408:
                case 410:
                case 414:
                case 398:
                case 422:
                case 438:
                case 440:
                case 442:
                case 428:
		case 504:
                case 492:
                case 807:
                case 446:
		case 470:
                case 484:
                case 458:
                case 528:
                case 578:
                case 554:
                case 512:
                case 591:
                case 604:
                case 608:
		case 586:
                case 616:
                case 630:
                case 620:
                case 634:
                case 642:
                case 643:
                case 682:
                case 752:
                case 702:
                case 703:
                case 705:
                case 222:
                case 760:	
		case 764:
                case 788:
                case 792:
                case 780:
                case 158:
                case 804:
                case 784:
                case 858:
                case 860:
                case 862:
                case 704:
                case 887:
                case 710:
                case 716: return 0;
			  break;
		default : 
			  return 1;
	}
}		

		

long isAlphaNumeric(u_char* ap_val)
{
 //snmp_log(LOG_ERR,"\n  ap name  = %s \n",ap_val);
 while(*ap_val != '\0')
    {
      if(!isalnum(*ap_val))
          return 1;
     ap_val++;
 }
 return 0;
}

long eval_RegionInfo(long reg_val)
{
char region_info[30] = {0};
char ret_val[4] = {0};

  strcpy(region_info,"system:monitor:region");
  rv = get_one(region_info,ret_val);
  if(rv)
       return SNMP_ERR_GENERR;
 
 if((!strcmp(ret_val,"NA")) && (reg_val != 840) && (reg_val != 124))
            return 1;
       else 
            return 0;
}

