/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dhcpsSettings.h"

dhcpsSettings node ;
char req_name[255],str[255];
int rv;
/* Validate IP Address */
extern long isValidIP(u_char*);
extern long check_ZeroIP(u_char*);
long eval_dhcpServerStatus(long);
/*
 * dhcpsSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dhcpsSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 12 };

/*
 * variable4 dhcpsSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dhcpsSettings mib section 
 */

struct variable4 dhcpsSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define DHCPSERVERSTATUS        1
    {DHCPSERVERSTATUS, ASN_INTEGER, RWRITE, var_dhcpsSettings, 1, {1}},
#define DHCPSVLANID             2 
    {DHCPSVLANID, ASN_INTEGER, RWRITE, var_dhcpsSettings, 1, {2}},
#define DHCPSIPSTART	        3
    {DHCPSIPSTART, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {3}},
#define DHCPSIPEND		4
    {DHCPSIPEND, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {4}},
#define DHCPNETMASK		5
    {DHCPNETMASK, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {5}},
#define DHCPSGATEWAY		6
    {DHCPSGATEWAY, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {6}},
#define DHCPSPRIDNS		7
    {DHCPSPRIDNS, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {7}},
#define DHCPSPSNDDNS		8
    {DHCPSPSNDDNS, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {8}},
#define DHCPSPRIWINS		9
    {DHCPSPRIWINS, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {9}},
#define DHCPSPSNDWINS		10
    {DHCPSPSNDWINS, ASN_IPADDRESS, RWRITE, var_dhcpsSettings, 1, {10}},
#define DHCPSLEASETIME		11
    {DHCPSLEASETIME, ASN_INTEGER, RWRITE, var_dhcpsSettings, 1, {11}},
};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the dhcpsSettings module */
void
init_dhcpsSettings(void)
{

    DEBUGMSGTL(("dhcpsSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dhcpsSettings", dhcpsSettings_variables, variable4,
                 dhcpsSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_dhcpsSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_dhcpsSettings(struct variable *vp,
                  oid * name,
                  size_t *length,
                  int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;
	char ret_buf[255];

        //memset(&node,0,sizeof(node));


    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:dhcpsSettings:");
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DHCPSERVERSTATUS:
        *write_method = write_dhcpserverStatus;
	*var_len = sizeof(int);

	if( !db_get(req_name,"dhcpServerStatus",ret_buf))
	        node.dhcpserver = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.dhcpserver;
    case DHCPSVLANID:
        *write_method = write_dhcpsVlanId;
        *var_len = sizeof(unsigned int);

        if( !db_get(req_name,"dhcpsVlanId",ret_buf))
           node.dhcpVlanId = atoi(ret_buf);

        else return NULL;
        return (u_char *) & node.dhcpVlanId;

    case DHCPSIPSTART:
        *write_method = write_dhcpsipstart;
	*var_len = 4 ;
	if( !db_get(req_name,"dhcpsIpStart",ret_buf)) {
        	rv = get_addr(node.dhcpsipstart,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpsipstart;
    case DHCPSIPEND:
        *write_method = write_dhcpsipend;
	*var_len = 4 ;
	if( !db_get(req_name,"dhcpsIpEnd",ret_buf)) {
		rv = get_addr(node.dhcpsipend,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpsipend;
    case DHCPNETMASK:
        *write_method = write_dhcpnetmask;
	*var_len = 4 ;
	if( !db_get(req_name,"dhcpsNetMask",ret_buf)) {
		rv = get_addr(node.dhcpnetmask,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpnetmask;
    case DHCPSGATEWAY:
        *write_method = write_dhcpsgateway;
	*var_len = 4 ;
	if( !db_get(req_name,"dhcpsGateway",ret_buf)) {
		rv = get_addr(node.dhcpsgateway,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpsgateway;
    case DHCPSPRIDNS:
        *write_method = write_dhcpspridns;
	*var_len = 4 ;

	if( !db_get(req_name,"dhcpsPriDns",ret_buf)) {
		rv = get_addr(node.dhcpspridns,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpspridns;
    case DHCPSPSNDDNS:
        *write_method = write_dhcpssnddns;
	*var_len = 4 ;

	if( !db_get(req_name,"dhcpsSndDns",ret_buf)) {
		rv = get_addr(node.dhcpssnddns,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpssnddns;
    case DHCPSPRIWINS:
        *write_method = write_dhcpspriwins;
	*var_len = 4 ;

	if( !db_get(req_name,"dhcpsPriWins",ret_buf)) {
		rv = get_addr(node.dhcpspriwins,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpspriwins;
    case DHCPSPSNDWINS:
        *write_method = write_dhcpssndwins;
	*var_len = 4 ;

	if( !db_get(req_name,"dhcpsSndWins",ret_buf)) {
		rv = get_addr(node.dhcpssndwins,ret_buf);
		if( rv ) return NULL;
	}
        else return NULL;
        return (u_char *) node.dhcpssndwins;
    case DHCPSLEASETIME:
        *write_method = write_dhcpsleasetime;
	*var_len = sizeof(int);

	if( !db_get(req_name,"dhcpsLeaseTime",ret_buf)){ 
           node.dhcpsleasetime = atoi(ret_buf);
           node.dhcpsleasetime = (node.dhcpsleasetime/60);
        }
        else return NULL;
        return (u_char *) & node.dhcpsleasetime;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

int
write_dhcpserverStatus(int action,
                 u_char * var_val,
                 u_char var_val_type,
                 size_t var_val_len,
                 u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dhcpsSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 0 && *(long*)var_val != 1 ) {
                fprintf(stderr, "write to dhcpsSettings : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	strcpy(req_name,"system:dhcpsSettings:dhcpServerStatus");
	sprintf(str,"%ld",value);
        rv = db_set(req_name,str);
	if(rv)
	{
        	return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save()){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_dhcpsVlanId(int action,
                 u_char * var_val,
                 u_char var_val_type,
                 size_t var_val_len,
                 u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dhcpsSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if (*(long*)var_val > 4094 || *(long*)var_val < 1) {
            fprintf(stderr, "write to dhcpsSettings : bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        value = *(long *)var_val;
        strcpy(req_name,"system:dhcpsSettings:dhcpsVlanId");
        sprintf(str,"%ld",value);
        rv = db_set(req_name,str);
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        if( db_save()){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_dhcpsipstart(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(check_ZeroIP(var_val))  {
            fprintf(stderr, "write to dhcpsSettings: zero IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
	    fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
	}
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsIpStart");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpsipstart[0],node.dhcpsipstart[1],node.dhcpsipstart[2],node.dhcpsipstart[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpsipend(int action,
                 u_char * var_val,
                 u_char var_val_type,
                 size_t var_val_len,
                 u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(check_ZeroIP(var_val))  {
            fprintf(stderr, "write to dhcpsSettings: zero IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
	if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsIpEnd");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpsipend[0],node.dhcpsipend[1],node.dhcpsipend[2],node.dhcpsipend[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpnetmask(int action,
                  u_char * var_val,
                  u_char var_val_type,
                  size_t var_val_len,
                  u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsNetMask");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpnetmask[0],node.dhcpnetmask[1],node.dhcpnetmask[2],node.dhcpnetmask[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpsgateway(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(check_ZeroIP(var_val))  {
            fprintf(stderr, "write to dhcpsSettings: zero IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsGateway");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpsgateway[0],node.dhcpsgateway[1],node.dhcpsgateway[2],node.dhcpsgateway[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpspridns(int action,
                  u_char * var_val,
                  u_char var_val_type,
                  size_t var_val_len,
                  u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
 	if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsPriDns");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpspridns[0],node.dhcpspridns[1],node.dhcpspridns[2],node.dhcpspridns[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpssnddns(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsSndDns");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpssnddns[0],node.dhcpssnddns[1],node.dhcpssnddns[2],node.dhcpssnddns[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpspriwins(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsPriWins");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpspriwins[0],node.dhcpspriwins[1],node.dhcpspriwins[2],node.dhcpspriwins[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpssndwins(int action,
                    u_char * var_val,
                    u_char var_val_type,
                    size_t var_val_len,
                    u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to dhcpsSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(isValidIP(var_val)) {
            fprintf(stderr, "write to dhcpsSettings: IP bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:dhcpsSettings:dhcpsSndWins");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.dhcpssndwins[0],node.dhcpssndwins[1],node.dhcpssndwins[2],node.dhcpssndwins[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_dhcpsleasetime(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dhcpsSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dhcpsSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val < 2 || *(long*)var_val > 143999 ) {
            fprintf(stderr, "write to dhcpsSettings : bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        if(eval_dhcpServerStatus(*(long*)var_val)) {
            fprintf(stderr, "write to dhcpsSettings: Server status is disabled\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
        value = value*60;
	sprintf(req_name,"system:dhcpsSettings:dhcpsLeaseTime");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.dhcpsleasetime));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

/* If dhcpServerStatus is disabled we can't set any of the variables of dhcpSettings Table except dhcpsVlANid  */
long eval_dhcpServerStatus(long ServerStatus)
{
    char buffer[50] = {0};
    int  status = 0;
    char val[10] = {0};

       strcpy(buffer,"system:dhcpsSettings:dhcpServerStatus");
       rv = get_one(buffer,val);
       if(rv)
	   return SNMP_ERR_GENERR;           
      
       status = atoi(val);
       snmp_log(LOG_ERR,"dhcpServerStatus = %d",status);	 
       if(status == 0)
            return 1;
       else
            return 0;
}

