/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "httpRedirectSettings.h"

httpRedirectSettings node ;
char req_name[255],str[255];
int rv;
long eval_httpStatus(long);
/*
 * httpRedirectSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             httpRedirectSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 14 };

/*
 * variable4 httpRedirectSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the httpRedirectSettings mib section 
 */

struct variable4 httpRedirectSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define HTTPREDIRECTSTATUS		1
    {HTTPREDIRECTSTATUS, ASN_INTEGER, RWRITE, var_httpRedirectSettings, 1,
     {1}},
#define HTTPREDIRECTURL		2
    {HTTPREDIRECTURL, ASN_OCTET_STR, RWRITE, var_httpRedirectSettings, 1,
     {2}},

};

/*
 * (L = length of the oidsuffix) 
 */



/** Initializes the httpRedirectSettings module */
void
init_httpRedirectSettings(void)
{

    DEBUGMSGTL(("httpRedirectSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("httpRedirectSettings", httpRedirectSettings_variables,
                 variable4, httpRedirectSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_httpRedirectSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_httpRedirectSettings(struct variable *vp,
                         oid * name,
                         size_t *length,
                         int exact,
                         size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;
	char ret_buf[255];
        //memset(&node,0,sizeof(node));

    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:httpRedirectSettings:");
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case HTTPREDIRECTSTATUS:
        *write_method = write_httpRedirectStatus;
	*var_len = sizeof(unsigned int);
	
	if( !db_get(req_name,"httpRedirectStatus",ret_buf))
        	node.httpRedirectStat = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.httpRedirectStat;
    case HTTPREDIRECTURL:
        *write_method = write_httpRedirectURL;

	if( !db_get(req_name,"httpRedirectURL",ret_buf))
		sprintf(node.httpRedirectURL,"%s",ret_buf);
        else return NULL;
	*var_len = strlen(node.httpRedirectURL);
        return (u_char *) & node.httpRedirectURL;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

int
write_httpRedirectStatus(int action,
                         u_char * var_val,
                         u_char var_val_type,
                         size_t var_val_len,
                         u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr,
                    "write to httpRedirectSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to httpRedirectSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 0 && *(long*)var_val != 1 ) {
                fprintf(stderr, "write to httpRedirectSettings: bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        if(eval_httpStatus(*(long*)var_val)) {
                fprintf(stderr, "write to httpRedirectSettings: bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;
    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:httpRedirectSettings:httpRedirectStatus");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.httpRedirectStat));  
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */	
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_httpRedirectURL(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to httpRedirectSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 119)) {
            fprintf(stderr, "write to httpRedirectSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:httpRedirectSettings:httpRedirectURL");
        strncpy(str,var_val,var_val_len);
        str[var_val_len] ='\0';

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.httpRedirectURL));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

/* dhcpServerstatus is disable , user can't enable httpRedirectstatus : throwing error */

long eval_httpStatus(long httpStatus)
{
    char buffer[50] = {0};
    char val[5] = {0};
    int status = 0;   
     //  snmp_log(LOG_ERR,"Entered eval_httpStatus  %d\n",httpStatus);
       strcpy(buffer,"system:dhcpsSettings:dhcpServerStatus");
       rv = get_one(buffer,val);
       if(rv)
           return SNMP_ERR_GENERR; 
       
       status = atoi(val);	   
       if((status == 0) && (httpStatus == 1))
           return 1;
       else  
           return 0;
}  

