/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "remoteSettings.h"

extern long isAlphaNumeric(u_char*);
extern long isValidIP(u_char*);

rem_Setgs node ;
char req_name[255];
int rv;

/*
 * remoteSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             remoteSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 6 };

/*
 * variable4 remoteSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the remoteSettings mib section 
 */

struct variable4 remoteSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define INACTIVITYTIMEOUT	1
    {INACTIVITYTIMEOUT, ASN_INTEGER, RWRITE, var_remoteSettings, 1, {1}},
#define SSHSTATUS	2
    {SSHSTATUS, ASN_INTEGER, RWRITE, var_remoteSettings, 1, {2}},
#define TELNETSTATUS	3
    {TELNETSTATUS, ASN_INTEGER, RWRITE, var_remoteSettings, 1, {3}},
#define SNMPSTATUS	4	
    {SNMPSTATUS, ASN_INTEGER, RONLY, var_remoteSettings, 1, {4}},
#define TRAPSERVERIP	5
    {TRAPSERVERIP, ASN_IPADDRESS, RWRITE, var_remoteSettings, 1, {5}},
#define TRAPSERVERCOMMUNITY	6
    {TRAPSERVERCOMMUNITY, ASN_OCTET_STR, RWRITE, var_remoteSettings, 1,
     {6}},
#define READONLYCOMMUNITY	7
    {READONLYCOMMUNITY, ASN_OCTET_STR, RWRITE, var_remoteSettings, 1, {7}},
#define READWRITECOMMUNITY	8
    {READWRITECOMMUNITY, ASN_OCTET_STR, RWRITE, var_remoteSettings, 1,
     {8}},

};

/*
 * (L = length of the oidsuffix) 
 */



/** Initializes the remoteSettings module */
void
init_remoteSettings(void)
{

    DEBUGMSGTL(("remoteSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("remoteSettings", remoteSettings_variables, variable4,
                 remoteSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_remoteSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_remoteSettings(struct variable *vp,
                   oid * name,
                   size_t *length,
                   int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;
	char ret_buf[255];

	memset(&node,0,sizeof(node));
    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:remoteSettings:");

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case INACTIVITYTIMEOUT:
        *write_method = write_inactivityTimeOut;
        *var_len = sizeof(int);

        if( !db_get(req_name,"inactivityTimeOut",ret_buf)) {
		node.inactivityTimeOut = atoi(ret_buf);
		snmp_log(LOG_ERR,"\n GET inactivityTimeOut = %s , %d \n",ret_buf,node.inactivityTimeOut);
	}
        else return NULL;
	snmp_log(LOG_ERR,"\n GET inactivityTimeOut = %s , %d \n",ret_buf,node.inactivityTimeOut);
        return (u_char *) & node.inactivityTimeOut;	
    case SSHSTATUS:
        *write_method = write_sshStatus;
	*var_len = sizeof(unsigned int);
		
	if( !db_get(req_name,"sshStatus",ret_buf))
		node.sshStat = atoi(ret_buf);
	else return NULL;	
        return (u_char *) & node.sshStat;
    case TELNETSTATUS:
        *write_method = write_telnetStatus;
        *var_len = sizeof(int);

        if( !db_get(req_name,"telnetStatus",ret_buf))
		node.telnetStat = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.telnetStat;
    case SNMPSTATUS:
	*write_method = write_snmpStatus;
	if( !db_get(req_name,"snmpStatus",ret_buf))
        	node.snmpStat = atoi(ret_buf);
	else return NULL;
	*var_len = sizeof(unsigned int);
        return (u_char *) & node.snmpStat;
    case TRAPSERVERIP:
        *write_method = write_trapServerIP;
	*var_len = 4 ;
	
	if( !db_get(req_name,"trapServerIP",ret_buf)) {
		rv = get_addr(node.trapServerIP,ret_buf);
		if( rv ) return NULL;
	}
	else return NULL;
        return (u_char *) & node.trapServerIP;
    case TRAPSERVERCOMMUNITY:
        *write_method = write_trapServerCommunity;
	
	if( !db_get(req_name,"trapServerCommunity",ret_buf))
		{
		strcpy(node.trapServerCommunity,ret_buf);
		}
	else return NULL;
	*var_len =strlen(node.trapServerCommunity);
        return (u_char *) & node.trapServerCommunity;
    case READONLYCOMMUNITY:
        *write_method = write_readOnlyCommunity;

	if( !db_get(req_name,"readOnlyCommunity",ret_buf))
		strcpy(node.readOnlyCommunity,ret_buf);
	else return NULL;
	*var_len =strlen(node.readOnlyCommunity);
        return (u_char *) & node.readOnlyCommunity;
    case READWRITECOMMUNITY:
        *write_method = write_readWriteCommunity;
	if( !db_get(req_name,"readWriteCommunity",ret_buf))
		strcpy(node.readWriteCommunity,ret_buf);
	else return NULL;
	*var_len =strlen(node.readWriteCommunity);
        return (u_char *) & node.readWriteCommunity;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

int
write_inactivityTimeOut(int action,
           u_char * var_val,
           u_char var_val_type,
           size_t var_val_len, u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
        char str[255];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to remoteSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:

        break;
    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
        sprintf(req_name,"system:remoteSettings:inactivityTimeOut");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        rv = db_set(req_name,(char *)&(node.inactivityTimeOut));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}




int
write_sshStatus(int action,
           u_char * var_val,
           u_char var_val_type,
           size_t var_val_len, u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
	char str[255];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to remoteSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val != 1 && *(long*)var_val != 0 ) {
            fprintf(stderr, "write to remoteSettings : bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */

	value = *(long *)var_val;
	sprintf(req_name,"system:remoteSettings:sshStatus");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
				
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.sshStat));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_telnetStatus(int action,
           u_char * var_val,
           u_char var_val_type,
           size_t var_val_len, u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
        char str[255];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to remoteSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if (*(long*)var_val != 1 && *(long*)var_val != 0 ) {
            fprintf(stderr, "write to remoteSettings : bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;
    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */

	value = *(long *)var_val;
        sprintf(req_name,"system:remoteSettings:telnetStatus");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        rv = db_set(req_name,(char *)&(node.telnetStat));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_snmpStatus(int action,
           u_char * var_val,
           u_char var_val_type,
           size_t var_val_len, u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
        char str[255];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to remoteSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if (*(long*)var_val != 0 && *(long*)var_val != 1 ) {
            fprintf(stderr, "write to remoteSettings : bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;
	case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */

	value = *(long *)var_val;
        sprintf(req_name,"system:remoteSettings:snmpStatus");
        sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }

        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        rv = db_set(req_name,(char *)&(node.snmpStat));
        if(rv)
        {
                return SNMP_ERR_GENERR;
        }
	break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_trapServerIP(int action,
                   u_char * var_val,
                   u_char var_val_type,
                   size_t var_val_len,
                   u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

	char str[16];
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to remoteSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > 4 ) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to remoteSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:remoteSettings:trapServerIP");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.trapServerIP[0],node.trapServerIP[1],node.trapServerIP[2],node.trapServerIP[3]);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_trapServerCommunity(int action,
                          u_char * var_val,
                          u_char var_val_type,
                          size_t var_val_len,
                          u_char * statP, oid * name, size_t name_len)
{
    char            *value,str[32];
    int             size;

    
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to remoteSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 31)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isAlphaNumeric(var_val)) {
            fprintf(stderr, "write to remoteSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = (char *) &var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:remoteSettings:trapServerCommunity");
	strncpy(str,var_val,var_val_len);
	str[var_val_len] ='\0';

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.trapServerCommunity));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_readOnlyCommunity(int action,
                        u_char * var_val,
                        u_char var_val_type,
                        size_t var_val_len,
                        u_char * statP, oid * name, size_t name_len)
{
    char            *value,str[32];
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to remoteSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1 ) || (var_val_len > 31)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isAlphaNumeric(var_val)) {
            fprintf(stderr, "write to remoteSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = (char *) &var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:remoteSettings:readOnlyCommunity");
	strncpy(str,var_val,var_val_len);
	str[var_val_len] ='\0';

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.readOnlyCommunity));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_readWriteCommunity(int action,
                         u_char * var_val,
                         u_char var_val_type,
                         size_t var_val_len,
                         u_char * statP, oid * name, size_t name_len)
{
    char            *value,str[32];
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to remoteSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 31)) {
            fprintf(stderr, "write to remoteSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(isAlphaNumeric(var_val)) {
            fprintf(stderr, "write to remoteSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = (char *) &var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:remoteSettings:readWriteCommunity");
        strncpy(str,var_val,var_val_len);
	str[var_val_len] ='\0';

	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
	
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	printf("\nUNDO\n");
	rv = db_set(req_name,(char *)&(node.readWriteCommunity));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}
