/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "timeSettings.h"
#include <time.h>

timeSettings node ;
char req_name[255],str[255];
int rv;

/*
 * timeSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             timeSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 11 };

/*
 * variable4 timeSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the timeSettings mib section 
 */

struct variable4 timeSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define CURRENTTIME		1
    {CURRENTTIME, ASN_OCTET_STR, RONLY, var_timeSettings, 1, {1}},
#define TIMEZONE		2
    {TIMEZONE, ASN_INTEGER, RWRITE, var_timeSettings, 1, {2}},
#define NTPCLIENTSTATUS		3
    {NTPCLIENTSTATUS, ASN_INTEGER, RWRITE, var_timeSettings, 1, {3}},
#define CUSTOMNTPSERVER		4
    {CUSTOMNTPSERVER, ASN_INTEGER, RWRITE, var_timeSettings, 1, {4}},
#define NTPADDR			5
    {NTPADDR, ASN_OCTET_STR, RWRITE, var_timeSettings, 1, {5}},

};

/*
 * (L = length of the oidsuffix) 
 */



/** Initializes the timeSettings module */
void
init_timeSettings(void)
{

    DEBUGMSGTL(("timeSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("timeSettings", timeSettings_variables, variable4,
                 timeSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_timeSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_timeSettings(struct variable *vp,
                 oid * name,
                 size_t *length,
                 int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	 char ret_buf[255],*p;
	memset(&node,0,sizeof(node));

    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:timeSettings:");

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case CURRENTTIME:
        {
        char buff[50] = {0};
        char *bp = NULL;
        int n = 50;
        FILE *fd = NULL;
	bp = &buff[0];
        fd = popen("date","r");
        if(fd != NULL) {
             getline(&bp,&n, fd);
        }
        pclose(fd);
        snmp_log(LOG_ERR,"current time %s\n",buff);
	 strcpy(node.currenttime,buff);
	*var_len = strlen(node.currenttime);
        return (u_char *) & node.currenttime;
       }
    case TIMEZONE:
        *write_method = write_timezone;
	*var_len = sizeof(unsigned int);

	if( !db_get(req_name,"timeZone",ret_buf))
		node.timezone = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.timezone;
    case NTPCLIENTSTATUS:
        *write_method = write_ntpClientStatus;
	*var_len = sizeof(unsigned int);

	if( !db_get(req_name,"ntpClientStatus",ret_buf))
		node.ntpCli_Stat = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.ntpCli_Stat;
    case CUSTOMNTPSERVER:
        *write_method = write_customNtpServer;
	*var_len = sizeof(unsigned int);

	if( !db_get(req_name,"customNtpServer",ret_buf))
		node.customNtpServer = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.customNtpServer;
    case NTPADDR:
        *write_method = write_ntpAddr;

	if( !db_get(req_name,"ntpAddr",ret_buf)) {
              strcpy(node.ntpAddr,ret_buf);
	}
	else return NULL;
        *var_len = strlen(node.ntpAddr);
        return (u_char *) node.ntpAddr;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

int
write_timezone(int action,
               u_char * var_val,
               u_char var_val_type,
               size_t var_val_len,
               u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to timeSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to timeSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val < 0 || *(long*)var_val > 279) {
                fprintf(stderr, "write to timeSettings: bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:timeSettings:timeZone");
	sprintf(str,"%lu",value);
	rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.timezone));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_ntpClientStatus(int action,
                u_char * var_val,
                u_char var_val_type,
                size_t var_val_len,
                u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to timeSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to timeSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 0 && *(long*)var_val != 1) {
                fprintf(stderr, "write to timeSettings : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:timeSettings:ntpClientStatus");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.ntpCli_Stat));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_customNtpServer(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to timeSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to timeSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 0 && *(long*)var_val != 1 ) {
                fprintf(stderr, "write to timeSettings : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:timeSettings:customNtpServer");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.customNtpServer)); 
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
	
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_ntpAddr(int action,
              u_char * var_val,
              u_char var_val_type,
              size_t var_val_len,
              u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to timeSettings not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1 ) || (var_val_len > 119 )) {
            fprintf(stderr, "write to timeSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	 strcpy(req_name,"system:timeSettings:ntpAddr");
         memcpy(str,var_val,var_val_len);
         str[var_val_len] = '\0';

         rv = db_set(req_name,str);
	 if(rv)
         {
                 return SNMP_ERR_GENERR;
         }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}
