/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "userCommand.h"
#include<sys/wait.h>
userCommand node ;
char req_name[255],str[255];
int rv;

/*
 * userCommand_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             userCommand_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 10 };

/*
 * variable4 userCommand_variables:
 *   this variable defines function callbacks and type return information 
 *   for the userCommand mib section 
 */

struct variable4 userCommand_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define RESETAP		1
    {RESETAP, ASN_INTEGER, RWRITE, var_userCommand, 1, {1}},
#define FIRMWAREUPGRADE		2
    {FIRMWAREUPGRADE, ASN_OCTET_STR, RWRITE, var_userCommand, 1, {2}},
#define BACKUPSETTINGS		3
    {BACKUPSETTINGS, ASN_OCTET_STR, RWRITE, var_userCommand, 1, {3}},
#define RESTORESETTINGS		4
    {RESTORESETTINGS, ASN_OCTET_STR, RWRITE, var_userCommand, 1, {4}},
#define RESTOREFACTORYDEFAULTS	5
    {RESTOREFACTORYDEFAULTS, ASN_INTEGER, RWRITE, var_userCommand, 1, {5}},
#define RESTOREDEFAULTPASSWORD  6
    {RESTOREDEFAULTPASSWORD, ASN_INTEGER, RWRITE, var_userCommand, 1, {6}},
};

/*
 * (L = length of the oidsuffix) 
 */

/** Initializes the userCommand module */
void
init_userCommand(void)
{

    DEBUGMSGTL(("userCommand", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("userCommand", userCommand_variables, variable4,
                 userCommand_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_userCommand():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_userCommand(struct variable *vp,
                oid * name,
                size_t *length,
                int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	char ret_buf[255];

        memset(&node,0,sizeof(node));

    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:userCommand:");
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case RESETAP:
        *write_method = write_resetAP;
		node.resetAP = 0;
        return (u_char *) & node.resetAP;
    case FIRMWAREUPGRADE:
        *write_method = write_firmwareUpgrade;
	
	*var_len = strlen(node.firmwareUpgrade);
        return (u_char *) node.firmwareUpgrade;
    case BACKUPSETTINGS:
        *write_method = write_backupSettings;

	*var_len = strlen(node.backupSettings);
        return (u_char *) node.backupSettings;
    case RESTORESETTINGS:
        *write_method = write_restoreSettings;

	*var_len = strlen(node.restoreSettings);
        return (u_char *) node.restoreSettings;
    case RESTOREFACTORYDEFAULTS:
        *write_method = write_restoreFactoryDefaults;
	
	*var_len = sizeof(unsigned int);
        return (u_char *) & node.restoreFactoryDefaults;
    case RESTOREDEFAULTPASSWORD:
	*write_method = write_restoreDefaultPassword;
                 node.restoreDefaultPassword = 0;
        *var_len = sizeof(unsigned int);
        return (u_char *) & node.restoreDefaultPassword;
    default:
        ERROR_MSG("");
    }
    return NULL;
}





int
write_resetAP(int action,
              u_char * var_val,
              u_char var_val_type,
              size_t var_val_len,
              u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to userCommand not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 1) {
                fprintf(stderr, "write to userCommand : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
        if(value == 1)
        system("reboot");
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_firmwareUpgrade(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to userCommand not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 100)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(char *) var_val;

        break;

    case FREE:	
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        {
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
         char firm_upgrade[50] = {0};      
	 strncpy(str,var_val,var_val_len);

           snmp_log(LOG_ERR,"\n script calling");
           strcpy(firm_upgrade,"/usr/local/bin/firmware-upgrade-wget ");
           strcat(firm_upgrade,str) ;
           system(firm_upgrade);
           snmp_log(LOG_ERR,"\n script executed");
        } 
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_backupSettings(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to userCommand not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 100)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        { 
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
         char bkp_Settings[50];
         char *host = NULL, *username = NULL ,*pwd = NULL ,*filename = NULL;       
         strncpy(str,var_val,var_val_len);
          
         host = strtok(str," ");
         username = strtok(NULL," ");
	 pwd = strtok(NULL," ");
	 filename = strtok(NULL," ");
 
         strcpy(bkp_Settings,"ftpput -u ");
         strcat(bkp_Settings, username);
         strcat(bkp_Settings," -p ");
         strcat(bkp_Settings, pwd);
         strcat(bkp_Settings," ");
         strcat(bkp_Settings,host);
         strcat(bkp_Settings," ");
         strcat(bkp_Settings,filename);
         strcat(bkp_Settings," /var/config");
         snmp_log(LOG_ERR,"\n back up Settings %s",bkp_Settings);

         system(bkp_Settings);
        
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_restoreSettings(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to userCommand not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if ((var_val_len < 1) || (var_val_len > 100)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        {
         char restr_Settings[50] = {0};
         char *host1 = NULL, *username1 = NULL ,*pwd1 = NULL ,*filename1 = NULL;
         strncpy(str,var_val,var_val_len);

         host1 = strtok(str," ");
         username1 = strtok(NULL," ");
         pwd1 = strtok(NULL," ");
         filename1 = strtok(NULL," ");
         
         strcpy(restr_Settings,"ftpget -u ");
         strcat(restr_Settings, username1);
         strcat(restr_Settings," -p ");
         strcat(restr_Settings, pwd1);
         strcat(restr_Settings," ");
         strcat(restr_Settings,host1);
         strcat(restr_Settings," /tmp/config ");
         strncat(restr_Settings,filename1, strlen(filename1));
         snmp_log(LOG_ERR,"\n restore Settings %s",restr_Settings);

         if((char) WEXITSTATUS(system(restr_Settings))){
                   snmp_log(LOG_ERR,"Unable to restore the configuration file\n");
                    return SNMP_ERR_WRONGVALUE;   
        }
        else {
                if((char) WEXITSTATUS(system("/usr/local/bin/verify-config.sh /tmp/config"))){
                        snmp_log(LOG_ERR,"Not a valid configuration file\n");
                        return SNMP_ERR_WRONGVALUE;
                }
                else
                        system("/usr/local/bin/restore-configuration /tmp/config");
        }
        return;
       }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_restoreFactoryDefaults(int action,
                             u_char * var_val,
                             u_char var_val_type,
                             size_t var_val_len,
                             u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to userCommand not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val != 1 ) {
                fprintf(stderr, "write to userCommand : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        {
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
          if(*(long*)var_val == 1 ) 
                system("cp -f /etc/default-config /var/config");
          system("reboot"); 
        } 
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
   }
    return SNMP_ERR_NOERROR;
}

int
write_restoreDefaultPassword(int action,
                             u_char * var_val,
                             u_char var_val_type,
                             size_t var_val_len,
                             u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to userCommand not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to userCommand: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(*(long*)var_val != 1 ) {
                fprintf(stderr, "write to userCommand : bad value\n");
                return SNMP_ERR_WRONGVALUE;
        }
        break;
    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated
         */
        break;

    case ACTION:
        {
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
          char buffer[50]={0};
 	  char buf1[50]={0};
	  FILE *fd = NULL;
 	  fd = popen("grep -i adminPasswd /etc/default-config | awk '{print $2}'","r");
	  if (fd != NULL) {
		fscanf(fd, "%s", buf1);
		pclose(fd);
	  }
          if(*(long*)var_val == 1 ) {
	  	strcpy(buffer,"system:basicSettings:adminPasswd");
	  	rv = db_set(buffer,buf1);
          	if(rv)
           	{
            
                	return SNMP_ERR_GENERR;
           	}
          }
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
         if( db_save() )
        {
                return SNMP_ERR_COMMITFAILED;
        }
        break;
   }
   return SNMP_ERR_NOERROR;
}

