
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <db_com.h>
#include "db.h"

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#define DEBUG_UTIL 0
#if DEBUG_UTIL
#define Printf(fmt,arg...) snmp_log(LOG_ERR,fmt,##arg)
#else
#define Printf(fmt,arg...)
#endif

#define SNMP_STR_LEN 255
#define ERR -1
#define SUCC 0
dbcom_handle db_hd;

static int idx;
static int flag;


int  mapnametoifIndex(char *name) 
{
	int index = -1;
	if(!strcmp(name,"wlan0")) index = 24;
	if(!strcmp(name,"wlan1")) index = 50;

	if(!strcmp(name,"vap0"))  index = 1;
	if(!strcmp(name,"vap1"))  index = 2;
	if(!strcmp(name,"vap2"))  index = 3;
	if(!strcmp(name,"vap3"))  index = 4;
	if(!strcmp(name,"vap4"))  index = 5;
	if(!strcmp(name,"vap5"))  index = 6;
	if(!strcmp(name,"vap6"))  index = 7;
	if(!strcmp(name,"vap7"))  index = 8;

	if(!strcmp(name,"wds0"))  index = 1;
	if(!strcmp(name,"wds1"))  index = 2;
	if(!strcmp(name,"wds2"))  index = 3;
        if(!strcmp(name,"wds3"))  index = 4;

	if(!strcmp(name,"1"))     index = 1;
	if(!strcmp(name,"2"))     index = 2;
	if(!strcmp(name,"3"))     index = 3;
	if(!strcmp(name,"4"))     index = 4;

	return(index);
}

int get_ifName(int ifIndex,char *ifName)
{
        if(ifIndex == 24)
                strcpy(ifName,"wlan0");
        else if(ifIndex == 50)
                strcpy(ifName,"wlan1");
        else
                return ERR;

        return SUCC;
}

int get_Qname(int qIndex,char *qName)
{
	if(qIndex == 1) strcpy(qName,"AC_BE");
	else if(qIndex == 2) strcpy(qName,"AC_BK");
	else if(qIndex == 3) strcpy(qName,"AC_VI");
	else if(qIndex == 4) strcpy(qName,"AC_VO");
	else
		return ERR;
	return SUCC;
}

void
init_utils(void)
{
        Printf("\nutils : dbcom_local_init()\n\n\n");
        if( init_db()) {
                snmp_log(LOG_ERR,"\n\n\tdbcom_local_init() :FAILED \n\n");
        }
}

int get_addr(char *addr,char *buf)
{
        char *ptr,ch,str[255];
        int ct=0,cnt = 0;
        ptr=buf;
        while(*ptr != '\0') {
                if(*ptr != '.') {
                        str[ct] = *ptr;
                        ct++;
                }
                else {
                        if(ct > 3) {
                                snmp_log(LOG_ERR,"\nINVALID DATA:IP ADDR\n");
                                return ERR;
                        }
                        str[ct] = '\0';
                        addr[cnt++] = atoi(str);
                        ct=0;
                }
                ptr++;
        }
        if(ct > 3) {
                snmp_log(LOG_ERR,"\nINVALID DATA:IP ADDR\n");
                return ERR;
        }
        str[ct] = '\0';
        addr[cnt++] = atoi(str);
        addr[cnt] = '\0';
        return SUCC;
}

int str_int (char *tmp,int num,char *n)
{
	int j;
        for(j = 0;j < num; j++)
	{
		if(('0' <= tmp[j]) && (tmp[j] <= '9'))
		{
	             tmp[j] = tmp[j] - '0';
		}
		else if(('A' <= tmp[j]) && (tmp[j] <= 'F'))
		{
                      tmp[j] = (tmp[j] - 'A') + 10;
		}
		else if( ('a' <= tmp[j]) &&  (tmp[j] <= 'f'))
		{
                      tmp[j] = (tmp[j] - 'a') + 10;
		}
		else
		{
                     snmp_log(LOG_ERR,"\nErr invalid mac\n");
                     return ERR;
		}
		*n = *n * 16 + tmp[j];
	}
	return SUCC;
}



int get_mac(char *str,u_char *mac)
{
	int i = 0,idx = 0;
	char tmp[3] = {0};
	char n = 0;
	while(*str != '\0')
	{
		if(*str == '-')
		{
			str++;
			{
				if(str_int(tmp,i,&n) == -1)
				{
					snmp_log(LOG_ERR,"\nErr invalid mac\n");
					return ERR; 
				}
				mac[idx++] = n; 
				i = 0;
			}
			continue;
		}
		else
		{
			tmp[i++] = *str++;
			if(i > 2)
			{
				snmp_log(LOG_ERR,"\nErr invalid mac\n");
				return ERR;
			}
		}
	}
	if(i)
	{
		if(str_int(tmp,i,&n) == -1)
		{
			snmp_log(LOG_ERR,"\nErr invalid mac\n");
			return ERR; 
		}
		mac[idx++] = n;
	} 
	mac[idx] = '\0';
	Printf("\nmac::%x %x %x %x %x %x\n\n",mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
	return SUCC;
		
}

void mac_str(char *mac,char *str)
{
        char ch,c;
        int num;
        int i = 0,j = 0;
        for(i = 0 ;i < 6 ; i++) {
                if(i != 0)
                        str[j++] = '-';
                ch = mac[i];

                ch = ch & 0xF0;
                ch = ch >>  4 ;
                ch = ch & 0x0F;
                if(ch >= 0 && ch <= 9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'A' + ch - 10;

                str[j++] = ch;

                ch = mac[i];
                ch = ch & 0x0F;
                if(ch>=0 && ch <=9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'A' + ch - 10;
                str[j++] = ch;

        }
        str[j] = '\0' ;
}


void func_row_macIdx(struct db_binding *binding,void *vptr)
{
        int i = 0;
        int index,exact;
        u_long *ptr = (u_long *)vptr;
        int *ptr1;
        char *ptr2;

        ptr2 = (char *) (*ptr);
        ptr1 = (int *) (*(ptr + 1));

        exact = *ptr1;
        index = *(ptr1 + 1);

        if(idx != -1)
                return;

	if(flag)
        {
                idx = 0;
                memcpy(ptr2,binding->name,strlen(binding->name));
                ptr2[strlen(binding->name)] = '\0';
        }
        if(!strcmp(ptr2,binding->name))
        {
                if(exact)
                {
                        idx = 0;
                        /*memcpy(ptr2,binding->name,strlen(binding->name));
                        ptr2[strlen(binding->name)] = '\0';*/
                }
                else
                        flag = 1;
        }
        return;
}


void func_row(struct db_binding *binding,void *vptr)
{
	int i = 0;
	int index,exact;
	u_long *ptr = (u_long *)vptr;
	int *ptr1;
	char *ptr2;

	ptr2 = (char *)	(*ptr);
	ptr1 = (int *) (*(ptr + 1));

	exact = *ptr1;
	index = *(ptr1 + 1);
		
	if(idx != -1)
		return;

	/*i = atoi (binding->value);*/
	/*snmp_log(LOG_ERR,"\nname = %s value = %s \n",binding->name,binding->value);*/
	i =  mapnametoifIndex(binding->name);
	if( i == -1 )
		return;

	if(flag)
	{
		idx = i;
		memcpy(ptr2,binding->name,strlen(binding->name));
		ptr2[strlen(binding->name)] = '\0';
	}
	if(index == i)
	{
		if(exact)
		{
			idx = i;
			memcpy(ptr2,binding->name,strlen(binding->name));
			ptr2[strlen(binding->name)] = '\0';
		}
		else
			flag = 1;
	}
	return;
}

int monitd_row(char *const name,int *index1,int *index2,char *name1,char *name2)
{
        char *rvptr,*errptr,*buf;
        int rv = 0;
        int flags = 0;
        struct db_binding *node,*tmp,*bind = NULL;
        char newname[256] = {0};

        rvptr = errptr = buf = NULL;

        if(!index1)
                return ERR;
	snmp_log(LOG_ERR,"monitd_row index1 = %d index2 = %d",*index1,*index2);
        flags = DBCOM_ITERATE_CHILDREN |DBCOM_ITERATE_VALUE;
        rv = dbcom_iterate (db_hd,name,flags,&bind,&errptr);
        if(rv)
        {
                if(errptr)
                {
                        snmp_log(LOG_ERR,"\nerr %s\n",errptr);
                        free(errptr);
                }
                if(bind)
                        free(bind);
                Printf("\nerr reading the data base\n");
                return ERR;
        }

        if(errptr)
        {
                free(errptr);
        }
        if(!bind)
        {
                Printf("\nNo data in bind\n");
                return ERR;
        }

        /* *index1 == -1 for non-Integer Index*/
        if(*index1 != -1) {
                *index1 = mapnametoifIndex(bind->name);
                snmp_log(LOG_ERR,"\nname index = %s value index  = %s \n",bind->name,bind->value);
                if(*index1 == -1)
                        return ERR;
        }
        else
                *index1 = 0;
        memcpy(name1,bind->name,strlen(bind->name));
        name1[strlen(bind->name)] = '\0';
        for(node = bind; node; node = tmp)
        {
                tmp = node -> next;
                free(node);
        }

        if(!index2)
                return SUCC;
        memset(newname,0,256);
        bind = NULL;
        strcpy(newname,name);
        strcat(newname,":");
        strcat(newname,name1);
        snmp_log(LOG_ERR,"\nnewname calling dbcom_iterate %s\n",newname);
        rv = dbcom_iterate (db_hd,newname,flags,&bind,&errptr);
        if(rv)
        {
                if(errptr)
                {
                        snmp_log(LOG_ERR,"\nerr %s\n",errptr);
                        free(errptr);
                }
                if(bind)
                        free(bind);
                Printf("\nerr reading the data base\n");
                return ERR;
        }
        if(errptr)
        {
                free(errptr);
        }
        if(!bind)
        {
                snmp_log(LOG_ERR,"\n name 1  %s\n",name1);
                if(!strcmp(name1,"wlan0"))
                      strcpy(name1,"wlan1");
                else if(!strcmp(name1,"wlan1"))
                      strcpy(name1,"wlan0");
                else    
                      return ERR;
 		 *index1 = mapnametoifIndex(name1);
                snmp_log(LOG_ERR,"index1 in bind %d",*index1);
                memset(newname,0,256);
                strcpy(newname,name);
                strcat(newname,":");
                strcat(newname,name1);
                snmp_log(LOG_ERR,"\nnewname under bind calling dbcom_iterate %s\n",newname);
        	rv = dbcom_iterate (db_hd,newname,flags,&bind,&errptr);
        	if(rv)
        	 {
                 	if(errptr)
                	{
                        snmp_log(LOG_ERR,"\nerr %s\n",errptr);
                        free(errptr);
                	}
                	if(bind)
                	        free(bind);
                	Printf("\nerr reading the data base\n");
                	return ERR;
                 }
        	 if(errptr)
        		{
                	free(errptr);
        		}
        	if(!bind)
			return ERR;        	 	
 	 }
       
        /* *index1 == -1 for non-Integer Index*/
        if(*index2 != -1) {
                snmp_log(LOG_ERR,"\n index2 != -1  %d in string %s\n",*index2,bind->name);
                *index2 = mapnametoifIndex(bind->name);
                if(*index2 == -1)
                        return ERR;
        }
        else
                *index2 = 0;
        memcpy(name2,bind->name,strlen(bind->name));
        name2[strlen(bind->name)] = '\0';
        snmp_log(LOG_ERR,"index 2 macaddr %s",bind->name);
        for(node = bind; node; node = tmp)
        {
                tmp = node -> next;
                free(node);
        }
      
        return rv;
}

int first_row(char *const name,int *index1,int *index2,char *name1,char *name2)
{
        char *rvptr,*errptr,*buf;
        int rv = 0;
	int flags = 0;
        struct db_binding *node,*tmp,*bind = NULL;
	char newname[256] = {0};

        rvptr = errptr = buf = NULL;
	
	if(!index1)
		return ERR;

        flags = DBCOM_ITERATE_CHILDREN |DBCOM_ITERATE_VALUE;
	rv = dbcom_iterate (db_hd,name,flags,&bind,&errptr);
	if(rv)
	{
		if(errptr)
		{	
			snmp_log(LOG_ERR,"\nerr %s\n",errptr);
			free(errptr);
		}
		if(bind)
			free(bind);
		Printf("\nerr reading the data base\n");
		return ERR;
	}

	if(errptr)
	{
		free(errptr);
	}
	if(!bind)
	{
		Printf("\nNo data in bind\n");
		return ERR;
	}
	
	/* *index1 == -1 for non-Integer Index*/
	if(*index1 != -1) {
		*index1 = mapnametoifIndex(bind->name);
                snmp_log(LOG_ERR,"\nname index = %s value index  = %s \n",bind->name,bind->value);
		if(*index1 == -1) 
			return ERR;
	}
	else 
		*index1 = 0;
	memcpy(name1,bind->name,strlen(bind->name));
	name1[strlen(bind->name)] = '\0';
	for(node = bind; node; node = tmp)
	{
		tmp = node -> next;
		free(node);
	}

	if(!index2)
		return SUCC;
	memset(newname,0,256);
	bind = NULL;
	strcpy(newname,name);
	strcat(newname,":");
	strcat(newname,name1);
        snmp_log(LOG_ERR,"\nnewname calling dbcom_iterate %s\n",newname);
	rv = dbcom_iterate (db_hd,newname,flags,&bind,&errptr);
	if(rv)
	{
		if(errptr)
		{	
			snmp_log(LOG_ERR,"\nerr %s\n",errptr);
			free(errptr);
		}
		if(bind)
			free(bind);
		Printf("\nerr reading the data base\n");
		return ERR;
	}
	if(errptr)
	{
		free(errptr);
	}
	if(!bind)
	{
		Printf("\nNo data in bind\n");
		return ERR;
	}
	
	/* *index1 == -1 for non-Integer Index*/
        if(*index2 != -1) {
		*index2 = mapnametoifIndex(bind->name);
		if(*index2 == -1)
			return ERR;
	}
	else
		*index2 = 0;
	memcpy(name2,bind->name,strlen(bind->name));
	name2[strlen(bind->name)] = '\0';
	for(node = bind; node; node = tmp)
	{
		tmp = node -> next;
		free(node);
	}
        return rv;
}

int get_row(char *const name,int exact,int *index,char *idx_name)
{
        char *errptr;
        int rv = 0;
	int flags = 0;
	char newname[256] = {0};
	char buf[5] = {0};
	int arr[2];
	u_long uarr[2];

	arr[0] = exact;
	arr[1] = *index;

	uarr[0] = (u_long) idx_name;
	uarr[1] = (u_long) arr;

        errptr = NULL;
        flags = DBCOM_ITERATE_CHILDREN | DBCOM_ITERATE_VALUE;
	

	idx = -1;
	flag = 0;
	if(*index == -1)
		rv = dbcom_iterate_func(db_hd,name,flags,func_row_macIdx,(void *)uarr,&errptr);
	else
		rv = dbcom_iterate_func(db_hd,name,flags,func_row,(void *)uarr,&errptr);
	if(rv)
	{
		if(errptr)
		{	
			Printf("\nerr %s\n",errptr);
			free(errptr);
		}
		return ERR;
	}
	if(errptr)
		free(errptr);	
	
	*index = idx; 
        return rv;
}

int db_get_row(char *dbname,int exact,int *index1,int *index2,char *idx_name1,char *idx_name2)
{
        int rv  = 0;
        char db_name[MAX_NAME_LEN];
        sprintf(db_name,"%s",dbname);

      //  snmp_log(LOG_ERR,"called db_get_row");
        if(exact)
        {
                rv = get_row(db_name,exact,index1,idx_name1);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nErr reading the data base\n");
                        return ERR;
                }
                if(*index1 == -1)
                {
                        return ERR;
                }
		if(!index2)
	                return SUCC;		

                sprintf(db_name,"%s",dbname);
                strcat(db_name,":");
                strcat(db_name,idx_name1);
                Printf("\ndb_name = %s \n",db_name);
                rv = get_row(db_name,exact,index2,idx_name2);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nErr reading the data base\n");
                        return ERR;
                }
                if(*index2 == -1)
                {
                        return ERR;
                }
                Printf("\n O/P idx1 = %d\tidx2 = %d\n\n",*index1,*index2);
                Printf("idx_name1 = %s\tidx_name2 = %s\n",idx_name1,idx_name2);
                return SUCC;
        }
        else
        {
                int tmp1,tmp2;
		if(index1)	tmp1 = *index1;
                if(index2)	tmp2 = *index2;

		if(!index2) 
			rv = get_row(db_name,exact,index1,idx_name1);
		else
	                rv = get_row(db_name,1,index1,idx_name1);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nErr reading the data base\n");
                        return ERR;
                }
                if(*index1 == -1)
                        return ERR;

		if(!index2) 
	                return SUCC;

                sprintf(db_name,"%s",dbname);
                strcat(db_name,":");
                strcat(db_name,idx_name1);
                rv = get_row(db_name,exact,index2,idx_name2);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nErr reading the data base\n");
                        return ERR;
                }

                if(*index2 == -1)
                {
                        *index1 = tmp1;
                        *index2 = tmp2;
                        memset(idx_name1,0,100);
                        sprintf(db_name,"%s",dbname);
			Printf("\nGetnext(index1) : db_name= %s\n",db_name);
                        rv = get_row(db_name,exact,index1,idx_name1);
                        if(rv)
                        {
                                Printf("\nErr reading the data base\n");
                                return ERR;
                        }
                        if(*index1 == -1){
				Printf("\nGetnext(index1) : ERR\n");
                                return ERR;
			}
                        sprintf(db_name,"%s",dbname);
                        strcat(db_name,":");
                        strcat(db_name,idx_name1);
                        memset(idx_name2,0,100);
			rv = first_row(db_name,index2,NULL,idx_name2,NULL);
                        if(rv)
                        {
                                Printf("\nErr reading the data base\n");
                                return ERR;
                        }
			Printf("\nGetnext(index1) : idx_name2= %s\n",idx_name2);	
                        if(*index2 == -1)
                                return ERR;
                }
                return SUCC;
        }
}


int get_one(char *const name,char *val)
{
	char *rvptr,*errptr,*buf;
	int rv = 0;
	rvptr = errptr = buf = NULL;
	
	rv = dbcom_get_one(db_hd,name,&buf,&errptr);
	if(rv)
	{
		if(errptr)
		{	
			Printf("\nerr %s\n",errptr);
			free(errptr);
		}
		return ERR;
	}
	if(errptr)
		free(errptr);
	if(buf)
	{
		strcpy(val,buf);
		val[strlen(buf)] = '\0';
		free(buf);
	}
	else
	{
		return ERR;
	}
	return rv;
}

int set_one(char *const name,char *val)
{
	char *rvptr,*errptr,*buf;
	int rv = 0;
	rvptr = errptr = buf = NULL;
	
	rv = dbcom_set_one(db_hd,name,val,&buf,&errptr);
	if(rv)
	{
		if(errptr)
		{	
			Printf("\nerr %s\n",errptr);
			free(errptr);
		}
		return ERR;
	}
	if(errptr)
		free(errptr);
	if(buf)
		free(buf);
	return rv;
}
int set_buffer(char *buf)
{
        char *rvptr,*errptr;
        int rv = 0;
        rvptr = errptr = NULL;

        rv = dbcom_set_buffer(db_hd,buf,&rvptr,&errptr);
        if(rv)
        {
                if(errptr)
                {
                        Printf("\nerr %s\n",errptr);
                        free(errptr);
                }
                return ERR;
        }
        if(errptr)
                free(errptr);
        if(rvptr)
                free(rvptr);
        return rv;
}

int init_db (void)
{
	db_hd = dbcom_local_init();
	if(db_hd == NULL )
                return ERR;
        else
                return SUCC;
}

int db_save(void)
{
	char *rvptr,*errptr;
	rvptr = errptr = NULL;
	int rv = 0;

        rv = dbcom_save (db_hd,&rvptr,&errptr);
	if(rvptr)
        	free(rvptr);
	if(errptr)
	        free(errptr);
	return (rv);
}



int db_get(char *req_name,char suff[],char *ret_buf)
{
	char *rvptr,*errptr,*buf;
        int rv = 0;
        rvptr = errptr = buf = NULL;

        strcat(req_name,suff);
        Printf("\n  req_name = %s \n\n",req_name);
        rv = dbcom_get_one(db_hd,req_name,&buf,&errptr);
        if(errptr)
                free(errptr);
        if(buf != NULL ){
                Printf("\n\nGET : buf = %s \n\n",buf);
                strcpy(ret_buf,buf);
                ret_buf[strlen(ret_buf)] = '\0';
                free(buf);
                return rv;
        }
        else {
                *ret_buf='\0';
                return ERR;
        }
}

int db_set(char *set_name,char *set_val)
{
	char *rvptr,*errptr;
        int rv = 0;
        rvptr = errptr = NULL;

        rv = dbcom_set_one(db_hd,set_name,set_val,&rvptr,&errptr);
        free(errptr);
        free(rvptr);
        if(rv == 0) {
                return rv ;
        }
        else {
                return ERR;
        }
}

int get_char(char *str,int ct,char *c)
{
        char ch;
        int i,num;
        for (i = 0 ; i < ct ; i++) {
                if(isdigit(str[i]))
                        num = str[i] - 48;
                else if(str[i] >= 'A' && str[i] <= 'F')
                        num = str[i] - 65 + 10;
                else if(str[i] >= 'a' && str[i] <= 'f')
                        num = str[i] - 97 + 10;
                else
                        return ERR;

                ch =(char)num ;
                if ( i == 0) *c = ch;
                else
                {
                        *c = *c << 4;
                        *c = *c | ch;
                }


        }
        return SUCC;
}
int get_mac_addr(char *addr,char *buf)
{
        char *ptr,ch,str[255],c = 0;
        int ct=0,cnt=0;;
        ptr=buf;
        while(*ptr != '\0') {
                if(*ptr != '-') {
                        str[ct]=*ptr;
                        ct++;
                }
                else {
                        if(ct > 2) {
                                snmp_log(LOG_ERR,"\nINVALID DATA:MAC ADDR\n");
                                return ERR;
                        }
                        str[ct] = '\0';
                        if( get_char(str,ct,&c) == -1) {
                                snmp_log(LOG_ERR,"\nINVALID DATA:MAC ADDR\n");
                                return ERR;
                        }
                        addr[cnt++] = c;
                        ct = 0;
                }
                ptr++;
        }
        if(ct > 2) {
                snmp_log(LOG_ERR,"\nINVALID DATA:MAC ADDR\n");
                return ERR;
        }
        str[ct] = '\0';
        if( get_char(str,ct,&c) == -1) {
		
                snmp_log(LOG_ERR,"\nINVALID DATA:MAC ADDR****\n");
                return ERR;
        }
        addr[cnt++] = c;
        addr[cnt] = '\0';

        return SUCC;
}


int wl_idx[2] = { 24, 50 };


int eval_wlanIndex(int idx)
{
	int rv = 0;
	char req_name[SNMP_STR_LEN];
	char idx_name[SNMP_STR_LEN];
	char ret_val[SNMP_STR_LEN];

	rv =  get_ifName(idx,idx_name);
	if(rv) 
		return rv;
	strcpy(req_name,"system:wlanSettings:wlanSettingTable:");
	strcat(req_name,idx_name);
	strcat(req_name,":radioStatus");
	rv = get_one(req_name,ret_val) ;
	if( rv )
		return ERR;
	else
	{
		snmp_log(LOG_ERR,"ret_val = %s\n",ret_val);
		if(atoi(ret_val) == 1)
			return SUCC;
		else 
			return ERR;
	}
}

int wlan_index(int *wlanindex)
{
    int rv=0;
   char temp1[100] = {0};
   char temp2[100] = {0};
   char ret1[50] = {0};
   char ret2[50] = {0};
        strcpy(temp1,"system:wlanSettings:wlanSettingTable:");
        strcat(temp1,"wlan0");
        strcat(temp1,":radioStatus");
        rv = get_one(temp1,ret1);
        if(rv)
             return ERR;

        strcpy(temp2,"system:wlanSettings:wlanSettingTable:");
        strcat(temp2,"wlan1");
        strcat(temp2,":radioStatus");
        rv = get_one(temp2,ret2);
        if(rv)
             return ERR;

       if(atoi(ret1) == 1) {
           *wlanindex =  wl_idx[0];
           return SUCC;
       }
       else if(atoi(ret2) == 1) {
           *wlanindex =  wl_idx[1];
           return SUCC;
       }
       else
           return ERR;
}

int get_wlanIndex_next(int *wlanindex)
{
	int i = 0,rv = 0;
	switch(*wlanindex) {
		case -1:
                
                        //snmp_log(LOG_ERR,"Entered -1 = \n");
			rv = eval_wlanIndex(wl_idx[0]);
			if(rv != ERR) {
				*wlanindex =  wl_idx[0];
				return SUCC;
			}
			break;
		case 24:
                        //snmp_log(LOG_ERR,"Entered 24 = \n");
			rv = eval_wlanIndex(wl_idx[1]);
			if(rv != ERR) {
				*wlanindex =  wl_idx[1];
				return SUCC;
			}
			break;
		case 50:
                       // snmp_log(LOG_ERR,"Entered 50 = \n");
                       // rv = eval_wlanIndex(wl_idx[1]);
                       // if(rv != ERR) {
                       //         *wlanindex =  wl_idx[1];
                       //         return SUCC;
                       // }
                        return ERR;
                        break;
	}
	return ERR;
}
/*Parse the mac-address list separated by semicolon*/
void parse_mac(char **ptr,char *mac)
{
	
        char *buf;
        buf = *ptr;
        // while((isspace(*buf)) && (*(buf+1) == ';'))
        //         buf++;
   	// while((*buf == ';') && (*(buf+1) == ';'))
   	//         buf++;	
        if( !strstr(buf,";") ) {
                while(*buf != '\0') {
			if(*buf != '\\')
	                        *mac++ = *buf;
			buf++;
		}
                *mac = '\0';
                *ptr = buf;
                return;
        }
        while( *buf != ';') {
		if(*buf != '\\')
	                *mac++ = *buf;
		buf++;
	}
        *mac = '\0';
        buf++;
        *ptr = buf;
        return;
}

#define MAC_LEN 100
typedef struct mac_list_t {
	char mac[MAC_LEN];
	struct mac_list_t *next;
}mac_list_t;
mac_list_t *mac_list_h = NULL;
				
void free_list(mac_list_t *list)
{
	mac_list_t *node,*temp;

	node = list;
	if(!node)
		return;
	else {
		temp = node;
		node = temp->next;
		free(temp);
	}
}
/*Get the mac address for the given table+wlan profile
 * name : db_name + idx_name1
 */
int load_maclist(char *name)
{
        char *ret_buf = NULL,*err_ptr = NULL;
        char *buf = NULL,*t = NULL;
	char mac[MAC_LEN] = {0};
	int rv = 0, flag = 0;
	
	free_list(mac_list_h);
	mac_list_h = NULL;
	mac_list_t *new,*temp;
        rv = dbcom_get_buffer(db_hd,name,&ret_buf,&err_ptr);
        if(rv || !ret_buf) {
		snmp_log(LOG_ERR,"\ndbcom_get_buffer :ERR \n%d",rv);
                return ERR;
	}	
        buf = ret_buf;
	while(!isspace(*buf))
                buf++;
        while( isspace(*buf))
                buf++;
        while(*buf == ';')
		buf++;

	while(*buf != '\0') {
                t = mac;
                parse_mac(&buf,t);
			
		new = (mac_list_t *)malloc(sizeof(mac_list_t));
		if(!new) {
			snmp_log(LOG_ERR,"\nmalloc :Failed");
			return ERR;
		}
		strcpy(new->mac,mac);
		new->next = NULL;
		if(!mac_list_h)
			mac_list_h = new;	
		else {			
			temp = mac_list_h;
			while(temp->next != NULL)
				temp = temp->next;
			temp->next = new;
                        new->next = NULL;
		}			
        }
	return SUCC;
}

int get_maclist(int exact,char *mac)
{
	mac_list_t *temp;
	int flag = 0;

	temp = mac_list_h;
        
	if(!temp)	//List Empty
		return ERR;
 
	if(exact == -1) {	//First row
		strcpy(mac,temp->mac);
                return SUCC;
        }
	while(temp)  {
		if(flag) {
			strcpy(mac,temp->mac);
                       // if(temp->next == NULL)
		        return SUCC;
		}			
		if(!strcmp(temp->mac,mac)) {
		         if(exact) {
                               //snmp_log(LOG_ERR,"get mac_list exact value id  = %d\n",exact);
				return SUCC;
                        }
                        
		        else {
				flag = 1;	
                         //snmp_log(LOG_ERR,"flag is 1 = %d\n",flag);
                        }
		}
		temp = temp->next;
               // strcpy(mac,temp->mac);
	}
	return ERR;
}

int get_row_monitd(char *db_name,int exact,int *index1,int *index2,char *idx_name1,char *idx_name2)
{
	int rv = 0;
	char req_name[SNMP_STR_LEN];

	//strcpy(req_name,db_name);
        //strcat(req_name,":");
        //strcat(req_name,idx_name1);
	//rv = load_maclist(req_name);
        //if(rv) {
	//        snmp_log(LOG_ERR,"\nload_maclist  :Err \n");
        //	return ERR;
        //}
	rv = get_maclist(exact,idx_name2);
	if(rv)
        {
        	if(exact) {
	        	snmp_log(LOG_ERR,"\nget_maclist :ERR\n");
	        	return ERR;
        	}
                else {
			snmp_log(LOG_ERR,"\n\n\n***************Next WlanIndex************\n\n");
                        rv = wlan_index(index1);
			if(rv == -1) {
                        	snmp_log(LOG_ERR,"\n get_wlanIndex_next :ERR\n");
                                return ERR;
			}
			rv =  get_ifName(index1,idx_name1);
		        if(rv)
                		return ERR;
		        //strcpy(req_name,db_name);
        		//strcat(req_name,":");
		        //strcat(req_name,idx_name1);
                        //rv = load_maclist(db_name);
			//if(rv) {
		        //        snmp_log(LOG_ERR,"\nload_maclist  :Err \n");
                	//	return ERR;
		        //}
			/*Get first mac : exact = -1*/
                        snmp_log(LOG_ERR,"\n *************************************** %s\n",idx_name2);
 
		        rv = get_maclist(-1,idx_name2);
                        if(rv) {
	                       	snmp_log(LOG_ERR,"\nget_maclist :ERR\n");
				return ERR;
			}                        
                }
	}
	return SUCC;
}
/*
 * parse_name_value()
 *
 * Given a buffer of one or more \n-terminated bindings, parses the
 * first one, escapes its name and value, returns them in allocated
 * buffers and returns the start of the next binding in newpos.
 */
int
parse_name_value(char *in, char **name, char **value, char **newpos)
{
    char *myname, *myvalue;
    char *namep, *valuep;
    int mode;

    myname = myvalue = namep= valuep = NULL;

    if (!in)
        return (1);

    myname = calloc(1, strlen(in) + 1);
    if (myname == NULL)
        return 1;

    myvalue = calloc(1, strlen(in) + 1);
    if (myvalue == NULL){
        free(myname);
        return 1;
    }

    mode = 0;
    namep = myname;
    valuep = myvalue;
    while ((*in) && (mode >= 0)) {
        switch (mode) {
        case 0:         /* name, normal */
            if (*in == ' ') {
                *in++;
                mode = 1;
                break;
            }
	    if(*in == '\n') {
		*in++;
		mode = -1;
		break;	
	    }
            *namep++ = *in++;
            break;
        case 1:         /* value, normal */
            if (*in == '\n') {  /* binding complete */
                *in++;
                mode = -1;
                break;
            }
            *valuep++ = *in++;
            break;
        }
    }
    *namep = '\0';
    *valuep = '\0';

    /*
     * Return name, value and newpos
     */
    if (name && strlen(myname)) {
        *name = myname;
    } else {
        free (myname);
	*name = NULL;
    }
    if (value && strlen(myvalue)) {
        *value = myvalue;
    } else {
        free (myvalue);
	*value = NULL;
    }
    if (newpos) {
        if (*in) {
            *newpos = in;
        } else {
            *newpos = NULL;
        }
    }
    return (0);
}
void parse_escape(char *ret_buf,char *buf)
{
	char *ptr1,*ptr2;
	ptr1 = ret_buf;
	ptr2 = buf;
	
	while(*ptr1 != '\0'){
		if(*ptr1 != '\\')
			*ptr2++ = *ptr1;
		ptr1++;
	}
	*ptr2 = '\0'; 
	//snmp_log(LOG_ERR,"ret_buf is = %s\n",ret_buf);
	//snmp_log(LOG_ERR,"buf is = %s\n",buf);
}

int get_one_monitd(char *const db_name,char mac[],char suff[],char *val)
{
	char *ret_buf = NULL;
        char *err_ptr = NULL;
	int	rv = 0;
	char	req_name[255],buf[5000];
	char   *name, *value, *bufp, *nextp;

	name = value = bufp = nextp = NULL;

	strcpy(req_name,db_name);
        strcat(req_name,":");
	strcat(req_name,mac);	//request format : name+mac
                rv = dbcom_get_buffer(db_hd,req_name,&ret_buf,&err_ptr);
		if(rv || !ret_buf) {
                	snmp_log(LOG_ERR,"\ndbcom_get_buffer :ERR \n");
			free(err_ptr);
		        return ERR;
	        }
	
	strcpy(req_name,db_name);
        strcat(req_name,":");
        strcat(req_name,mac);
        strcat(req_name,":"); 
	strcat(req_name,suff); //return value format : name+suff

	parse_escape(ret_buf,buf);
        //snmp_log(LOG_ERR,"\n return buffer after parse escape = %s\n",buf);
	bufp = buf;
        
	/*Parse the first Line of the ret_buf*/
	while(*bufp != '\n')
		bufp++;
	bufp++;
	
	nextp = bufp;
	while(bufp) {
		//snmp_log(LOG_ERR,"\nbufp = %s\n",bufp);
        	rv = parse_name_value(bufp, &name, &value, &nextp);
                //snmp_log(LOG_ERR,"\n name and value is  = %s\n%s\n",name,value);  
		if (rv) {
                	/* Error */
			free(ret_buf);
			return ERR;
		} 
		else {
                	/*
                	 * Compare the request-name with the bind -name.
	                 */
			if(name == NULL && value == NULL)
				break;
	
			#if 0			
			if(name)
				snmp_log(LOG_ERR,"\nname = %s\n",name);
			if(value)
				snmp_log(LOG_ERR,"\nvalue = %s\n",value);
			#endif
			if (strcmp(req_name, name) == 0) {
				if(value){
	                	        strncpy(val, value, strlen(value));
        	                	val[strlen(value)] = '\0';
					snmp_log(LOG_ERR,"\n Matched *****\n");
					//snmp_log(LOG_ERR,"\nname=%s , value=%s\n\n",name,value);			
					//snmp_log(LOG_ERR,"\nval =%s\n",val);			
					free(name);
					free(value);
				}
				return SUCC;			
			}
		        /*
        	         * Free the current name/value, and advance to the
	                 * next one.
                	*/
	                free(name);
        	        free(value);
                	bufp = nextp;
            	}
        }
        free(ret_buf);
	return ERR;
}



int get_mac_1(char *str,u_char *mac)
{
        int i = 0,idx = 0;
        char tmp[3] = {0};
        char n = 0;
        while(*str != '\0')
        {
                if(*str == '-')
                {
                        str++;
                        {
                                if(str_int(tmp,i,&n) == -1)
                                {
                                        snmp_log(LOG_ERR,"\nErr invalid mac\n");
                                        return ERR;
                                }
                                mac[idx++] = n;
                                i = 0;
                        }
                        continue;
                }
                else
                {
                        tmp[i++] = *str++;
                        if(i > 2)
                        {
                                snmp_log(LOG_ERR,"\nErr invalid mac\n");
                                return ERR;
                        }
                }
        }
        if(i)
        {
                if(str_int(tmp,i,&n) == -1)
                {
                        snmp_log(LOG_ERR,"\nErr invalid mac\n");
                        return ERR;
                }
                mac[idx++] = n;
        }
        mac[idx] = '\0';
        Printf("\nmac::%x %x %x %x %x %x\n\n",mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
       // sprintf(mac,"%x%x%x%x%x%x",mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
       // snmp_log(LOG_ERR,"mac is = %s",mac);
        return SUCC;

}

void mac_str_1(char *mac,char *str)
{
        char ch,c;
        int num;
        int i = 0,j = 0;
        for(i = 0 ;i < 6 ; i++) {
                if(i != 0)
                        str[j++] = '-';
                ch = mac[i];

                ch = ch & 0xF0;
                ch = ch >>  4 ;
                ch = ch & 0x0F;
                if(ch >= 0 && ch <= 9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'a' + ch - 10;
                str[j++] = ch;

                ch = mac[i];
                ch = ch & 0x0F;
                if(ch>=0 && ch <=9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'a' + ch - 10;
                str[j++] = ch;
        }
        str[j] = '\0' ;
}

void mac_str_2(char *mac,char *str)
{
        char ch,c;
        int num;
        int i = 0,j = 0;
        for(i = 0 ;i < 6 ; i++) {
                if(i != 0)
                        str[j++] = '-';
                ch = mac[i];

                ch = ch & 0xF0;
                ch = ch >>  4 ;
                ch = ch & 0x0F;
                if(ch >= 0 && ch <= 9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'A' + ch - 10;
                str[j++] = ch;

                ch = mac[i];
                ch = ch & 0x0F;
                if(ch>=0 && ch <=9 )
                        ch = '0' + ch;
                else if(ch >= 10 && ch <= 15)
                        ch = 'A' + ch - 10;
                str[j++] = ch;
        }
        str[j] = '\0' ;
}

int get_buffer(char *req_name,char *ret_val)
{
	char *ret_buf,*err_ptr;
	int rv = 0;
	ret_buf = err_ptr = NULL;

	rv = dbcom_get_buffer(db_hd,req_name,&ret_buf,&err_ptr);
        if(rv || !ret_buf) {
                snmp_log(LOG_ERR,"\ndbcom_get_buffer :ERR \n");
                free(err_ptr);
                return ERR;
        }
	strcpy(ret_val,ret_buf);
	free(ret_buf);
	free(err_ptr);
	return SUCC;
}

int wds_mac(char *rem ,u_char *d)
{
        unsigned short c[12]={0};
 snmp_log(LOG_ERR,"\nmac under utils.c = %s\n",rem);
        int i, j = 0;
        for (i =0; i <= (strlen(rem) -1); i++)
        {
                if (rem[i] == '-')
                        continue;
                if (rem[i] >= '0' && rem[i] <= '9')
                        c[j] = rem[i] - '0';
                if (rem[i] >= 'a' && rem[i] <= 'f')
                        c[j] = rem[i] - 'a' + 10;
                if (rem[i] >= 'A' && rem[i] <= 'F')
                        c[j] = (rem[i] - 'A') + 10;
              snmp_log(LOG_ERR,"c[j] value is %X",c[j]);
                j++;
        }
        putchar('\n');
        j = 0;
        for (i =0; i <= 10; i++)
        {
                d[j] =  (c[i++] & 0x0F) << 4;
                d[j] |= (c[i] & 0x0F);
                snmp_log(LOG_ERR," d[j] value is %02X",d[j]);
                j++;
        }
        putchar('\n');
        return 0;
}

put_wds(unsigned char *dst, unsigned char *src)
{
    int i = 0, j = 0;
    dst[2] = dst[5]= dst[8] = dst[11] = dst[14] = '-';
        for (i = 0; i<=17; i++)
          {
            if(dst[i] == '-')
              continue;
            dst[i] = src[j];
	    j++;
          }
}


int get_ap_monitd(char *db_name,int exact,int *index1,int *index2,char *idx_name1,char *idx_name2)
{
	int rv = 0;
	char req_name[SNMP_STR_LEN];

	rv = wlan_index(index1);
        if( rv == -1 ) {
        	return ERR;
        }
	rv =  get_ifName(*index1,idx_name1);
        if(rv)
                return rv;
	strcpy(req_name,db_name);
        strcat(req_name,":");
        strcat(req_name,idx_name1);
	rv = load_maclist(req_name);
        if(rv) {
	        snmp_log(LOG_ERR,"\nload_maclist  :Err \n");
        	return ERR;
        }
	rv = get_maclist(exact,idx_name2);
	if(rv)
        {
        	if(exact) {
	        	snmp_log(LOG_ERR,"\nget_maclist :ERR\n");
	        	return ERR;
        	}
                else {
			snmp_log(LOG_ERR,"\n\n\n***************Next WlanIndex************\n\n");
                	rv = wlan_index(index1);
			if(rv == -1) {
                        	snmp_log(LOG_ERR,"\n get_wlanIndex_next :ERR\n");
                                return ERR;
			}
			rv =  get_ifName(*index1,idx_name1);
		        if(rv)
                		return ERR;
		        strcpy(req_name,db_name);
        		strcat(req_name,":");
		        strcat(req_name,idx_name1);
                        rv = load_maclist(db_name);
			if(rv) {
		                snmp_log(LOG_ERR,"\nload_maclist  :Err \n");
                		return ERR;
		        }
			/*Get first mac : exact = -1*/
		        rv = get_maclist(-1,idx_name2);
                        if(rv) {
	                       	snmp_log(LOG_ERR,"\nget_maclist :ERR\n");
				return ERR;
			}                        
                }
	}
	return SUCC;
}
