/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11PhyTxPowerTable.h"
#include "ieee802dot11_info.h"
#include "PhyTxPower.h"

list_T TxPowList;

/*
 * dot11PhyTxPowerTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11PhyTxPowerTable_variables_oid[] =
    { 1, 2, 840, 10036, 4, 3 };

/*
 * variable4 dot11PhyTxPowerTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11PhyTxPowerTable mib section 
 */

struct variable7 dot11PhyTxPowerTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11NUMBERSUPPORTEDPOWERLEVELS		1
    {DOT11NUMBERSUPPORTEDPOWERLEVELS, ASN_INTEGER, RONLY,
     var_dot11PhyTxPowerTable, 2, { 1, 1}},
#define DOT11TXPOWERLEVEL1		2
    {DOT11TXPOWERLEVEL1, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 2}},
#define DOT11TXPOWERLEVEL2		3
    {DOT11TXPOWERLEVEL2, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 3}},
#define DOT11TXPOWERLEVEL3		4
    {DOT11TXPOWERLEVEL3, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 4}},
#define DOT11TXPOWERLEVEL4		5
    {DOT11TXPOWERLEVEL4, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 5}},
#define DOT11TXPOWERLEVEL5		6
    {DOT11TXPOWERLEVEL5, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 6}},
#define DOT11TXPOWERLEVEL6		7
    {DOT11TXPOWERLEVEL6, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 7}},
#define DOT11TXPOWERLEVEL7		8
    {DOT11TXPOWERLEVEL7, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 8}},
#define DOT11TXPOWERLEVEL8		9
    {DOT11TXPOWERLEVEL8, ASN_INTEGER, RONLY, var_dot11PhyTxPowerTable, 2,
     { 1, 9}},
#define DOT11CURRENTTXPOWERLEVEL		10
    {DOT11CURRENTTXPOWERLEVEL, ASN_INTEGER, RONLY,
     var_dot11PhyTxPowerTable, 2, { 1, 10}},
};

/*
 * (L = length of the oidsuffix) 
 */

void init_TxPowList()
{
        LIST_INIT (&TxPowList);
}



/** Initializes the dot11PhyTxPowerTable module */
void
init_dot11PhyTxPowerTable(void)
{

    DEBUGMSGTL(("dot11PhyTxPowerTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11PhyTxPowerTable", dot11PhyTxPowerTable_variables,
                 variable7, dot11PhyTxPowerTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	init_TxPowList();
}


/*
 * var_dot11PhyTxPowerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11PhyTxPowerTable above.
 */
unsigned char  *
var_dot11PhyTxPowerTable(struct variable *vp,
                         oid * name,
                         size_t *length,
                         int exact,
                         size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	int i,len=0,rtest;
        oid newname[MAX_OID_LEN];

        TxpowTbl_data *TxPowTbl_node = NULL;

        for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

        /*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 1)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

        if(load_Table(loadTxPowList,&TxPowList)) {
                snmp_log(LOG_ERR,"TxPowList Table return -1\n");
                return NULL;
        }
	if(LIST_EMPTY(&TxPowList)) {
                snmp_log(LOG_ERR,"TxPowList Table: TxPowList head is NULL\n");
                return NULL;
        }
        memset (newname, 0, sizeof(newname));
        memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
        /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen || rtest == -1 )
        {
                len = vp->namelen;
                TxPowTbl_node = (TxpowTbl_data *) TxPowList.l_head->data;
                newname[len] = TxPowTbl_node->ifIndex;
                *length = vp->namelen + 1;
        }

        /*Case3:When namelength is greater than or equal to vpnamelen+1*/
        else if( (int)*length >= (int) (vp->namelen+1) )
        {
                len = vp->namelen;
                TxPowTbl_node = TxPowList_get(&TxPowList,(int)name[len],exact);
                if(!TxPowTbl_node)
                {
                        return NULL;
                }
                newname[len] = TxPowTbl_node->ifIndex;
                *length = vp->namelen + 1;
        }

        memcpy(name,newname,(*length) * sizeof(oid));
        *var_len = sizeof(int);         /*Default*/
        *write_method = NULL;           /*Default*/

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11NUMBERSUPPORTEDPOWERLEVELS:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->NumPowL;*/
    case DOT11TXPOWERLEVEL1:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL1;*/
    case DOT11TXPOWERLEVEL2:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL2;*/
    case DOT11TXPOWERLEVEL3:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL3;*/
    case DOT11TXPOWERLEVEL4:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL4;*/
    case DOT11TXPOWERLEVEL5:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL5;*/
    case DOT11TXPOWERLEVEL6:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL6;*/
    case DOT11TXPOWERLEVEL7:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL7;*/
    case DOT11TXPOWERLEVEL8:
	return NULL;
        /*return (u_char *) & TxPowTbl_node->PowL8;*/
    case DOT11CURRENTTXPOWERLEVEL:
        return (u_char *) & TxPowTbl_node->CurrPowL;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

