/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11PrivacyTable.h"
#include "ieee802dot11_info.h"
#include "Privacy.h"
/*
 * dot11PrivacyTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11PrivacyTable_variables_oid[] =
    { 1, 2, 840, 10036, 1, 5 };

/*
 * variable4 dot11PrivacyTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11PrivacyTable mib section 
 */

struct variable7 dot11PrivacyTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11PRIVACYINVOKED		1
    {DOT11PRIVACYINVOKED, ASN_INTEGER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 1}},
#define DOT11WEPDEFAULTKEYID		2
    {DOT11WEPDEFAULTKEYID, ASN_INTEGER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 2}},
#define DOT11EXCLUDEUNENCRYPTED		3
    {DOT11EXCLUDEUNENCRYPTED, ASN_INTEGER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 4}},
#define DOT11WEPICVERRORCOUNT		4
    {DOT11WEPICVERRORCOUNT, ASN_COUNTER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 5}},
#define DOT11WEPEXCLUDEDCOUNT		5
    {DOT11WEPEXCLUDEDCOUNT, ASN_COUNTER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 6}},
#define DOT11RSNAENABLED		6
    {DOT11RSNAENABLED, ASN_INTEGER, RONLY, var_dot11PrivacyTable, 2,
     { 1, 7}},
#define DOT11RSNAPREAUTHENTICATIONENABLED		7
    {DOT11RSNAPREAUTHENTICATIONENABLED, ASN_INTEGER, RONLY,
     var_dot11PrivacyTable, 2, { 1, 8}},
};

/*
 * (L = length of the oidsuffix) 
 */
list_T prv_list;

void init_priv()
{
	LIST_INIT (&prv_list);
}

/** Initializes the dot11PrivacyTable module */
void
init_dot11PrivacyTable(void)
{

    DEBUGMSGTL(("dot11PrivacyTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11PrivacyTable", dot11PrivacyTable_variables,
                 variable7, dot11PrivacyTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	init_priv();
}

/*
 * var_dot11PrivacyTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11PrivacyTable above.
 */
unsigned char  *
var_dot11PrivacyTable(struct variable *vp,
                      oid * name,
                      size_t *length,
                      int exact,
                      size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;


	prvTbl_data *npr;
	int i,len=0,rtest;
	oid newname[MAX_OID_LEN];

	for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

	/*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 1)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

	/*
	*Load Privacy List Tables
	*/
	if(load_Table(load_prvtbl,&prv_list))
	{
		snmp_log(LOG_ERR,"Sctble load failed\n");
		return NULL;
	}

	if(LIST_EMPTY (&prv_list) )
	{
		snmp_log(LOG_ERR,"\nAuthentication Algo Tabe Empty\n");
		return NULL;
	}
	
	memset (newname, 0, sizeof(newname));
	memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
	
	 /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen || rtest == -1 )
        {
                len = vp->namelen;
                npr = (prvTbl_data *) prv_list.l_head->data;
                newname[len] = npr->ifindex;
                *length = vp->namelen + 1;
	}

	/*Case3:When namelength is greater than or equal to vpnamelen+1*/
        else if( (int)*length >= (int) (vp->namelen+1) )
        {
                len = vp->namelen;
                npr = PrvList_get(&prv_list,(int)name[len],exact);
                if(!npr)
                {
                        return NULL;
                }
                newname[len] = npr->ifindex;
                *length = vp->namelen + 1;
        }

        memcpy(name,newname,(*length) * sizeof(oid));
        *var_len = sizeof(int);      /*Default*/
	*write_method = NULL;
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11PRIVACYINVOKED:
        return (u_char *) & npr -> priv_invoked;
    case DOT11WEPDEFAULTKEYID:
        return (u_char *) & npr -> key_id;
    case DOT11EXCLUDEUNENCRYPTED:
        return (u_char *) & npr -> unencrypted;
    case DOT11WEPICVERRORCOUNT:
        return (u_char *) & npr -> err_cnt;
    case DOT11WEPEXCLUDEDCOUNT:
        return (u_char *) & npr -> exld_cnt;
    case DOT11RSNAENABLED:
        return (u_char *) & npr -> RSNA_enb;
    case DOT11RSNAPREAUTHENTICATIONENABLED:
        return (u_char *) & npr -> RSNAPre_enb;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
