/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11SupportedDataRatesTxTable.h"
#include "ieee802dot11_info.h"
#include "DataRates.h"

/*
 * dot11SupportedDataRatesTxTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11SupportedDataRatesTxTable_variables_oid[] =
    { 1, 2, 840, 10036, 4, 9 };

/*
 * variable4 dot11SupportedDataRatesTxTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11SupportedDataRatesTxTable mib section 
 */

struct variable7 dot11SupportedDataRatesTxTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11SUPPORTEDDATARATESTXINDEX		1
    {DOT11SUPPORTEDDATARATESTXINDEX, ASN_INTEGER, RONLY,
     var_dot11SupportedDataRatesTxTable, 2, { 1, 1}},
#define DOT11SUPPORTEDDATARATESTXVALUE		2
    {DOT11SUPPORTEDDATARATESTXVALUE, ASN_INTEGER, RONLY,
     var_dot11SupportedDataRatesTxTable, 2, { 1, 2}},
};

/*
 * (L = length of the oidsuffix) 
 */
list_T rt_list;
void init_rt()
{
	LIST_INIT (&rt_list);
}	


/** Initializes the dot11SupportedDataRatesTxTable module */
void
init_dot11SupportedDataRatesTxTable(void)
{

    DEBUGMSGTL(("dot11SupportedDataRatesTxTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11SupportedDataRatesTxTable",
                 dot11SupportedDataRatesTxTable_variables, variable7,
                 dot11SupportedDataRatesTxTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	init_rt();
}



/*
 * var_dot11SupportedDataRatesTxTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11SupportedDataRatesTxTable above.
 */
unsigned char  *
var_dot11SupportedDataRatesTxTable(struct variable *vp,
                                   oid * name,
                                   size_t *length,
                                   int exact,
                                   size_t *var_len,
                                   WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	rtTbl_data *rt;
	int i,len=0,rtest;
	oid newname[MAX_OID_LEN];

	for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

	/*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 2)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

	/*
	*Load Data Rate TX List Tables
	*/
	if(load_Table(load_rttbl,&rt_list))
	{
		snmp_log(LOG_ERR,"Sctble load failed\n");
		return NULL;
	}

	if(LIST_EMPTY (&rt_list) )
	{
		snmp_log(LOG_ERR,"\nAuthentication Algo Tabe Empty\n");
		return NULL;
	}
	
	
	memset (newname, 0, sizeof(newname));
	memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
	
	 /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen || rtest == -1 || 
		(int) *length == (int) (vp->namelen + 1))
        {
                len = vp->namelen;
                rt = (rtTbl_data *) rt_list.l_head->data;
                newname[len] = rt->ifindex;
		newname[len + 1] = rt->index;
                *length = vp->namelen + 2;
        }

	/*Case3:When namelength is greater than or equal to vpnamelen + 2*/
        else if( (int)*length >= (int) (vp->namelen + 2) )
        {
                len = vp->namelen;
                rt = rtList_get(&rt_list,(int)name[len],(int)name[len+1],exact);
                if(!rt)
                {
                        return NULL;
                }
                newname[len] = rt->ifindex;
                newname[len + 1] = rt->index;
                *length = vp->namelen + 2;
	}

        memcpy(name,newname,(*length) * sizeof(oid));
	*var_len = sizeof(int);	/*Default*/
	*write_method = NULL;	
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11SUPPORTEDDATARATESTXINDEX:
        return (u_char *) & rt->index;
    case DOT11SUPPORTEDDATARATESTXVALUE:
        return (u_char *) & rt->txval;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
