/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11SupportedMCSTxTable.h"
#include "ieee802dot11_info.h"
#include "MCSTxTable.h"

list_T smTxList;

/*
 * dot11SupportedMCSTxTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11SupportedMCSTxTable_variables_oid[] =
    { 1, 2, 840, 10036, 4, 16 };

/*
 * variable4 dot11SupportedMCSTxTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11SupportedMCSTxTable mib section 
 */

struct variable7 dot11SupportedMCSTxTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11SUPPORTEDMCSTXINDEX		1
    {DOT11SUPPORTEDMCSTXINDEX, ASN_INTEGER, RONLY,
     var_dot11SupportedMCSTxTable, 2, { 1, 1}},
#define DOT11SUPPORTEDMCSTXVALUE		2
    {DOT11SUPPORTEDMCSTXVALUE, ASN_INTEGER, RONLY,
     var_dot11SupportedMCSTxTable, 2, { 1, 2}},
};

/*
 * (L = length of the oidsuffix) 
 */

void init_smTx()
{
        LIST_INIT (&smTxList);
}


/** Initializes the dot11SupportedMCSTxTable module */
void
init_dot11SupportedMCSTxTable(void)
{

    DEBUGMSGTL(("dot11SupportedMCSTxTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11SupportedMCSTxTable",
                 dot11SupportedMCSTxTable_variables, variable7,
                 dot11SupportedMCSTxTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	
	init_smTx();
}

/*
 * var_dot11SupportedMCSTxTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11SupportedMCSTxTable above.
 */
unsigned char  *
var_dot11SupportedMCSTxTable(struct variable *vp,
                             oid * name,
                             size_t *length,
                             int exact,
                             size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	int i,len=0,rtest;
        oid newname[MAX_OID_LEN];

        smTxtbl_data *smTxtbl_node = NULL;

        for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

        /*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 2)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

        if(load_Table(loadsmTxList,&smTxList)) {
                snmp_log(LOG_ERR,"smTxList Table return -1\n");
                return NULL;
        }
	if(LIST_EMPTY(&smTxList)) {
                snmp_log(LOG_ERR,"smTxList Table: smTxList head is NULL\n");
                return NULL;
        }
        memset (newname, 0, sizeof(newname));
        memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
        /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen +1  || rtest == -1 )
        {
                len = vp->namelen;
                smTxtbl_node = (smTxtbl_data *) smTxList.l_head->data;
                newname[len]  = smTxtbl_node->ifIndex;
		newname[len+1]= smTxtbl_node->MCSTxIndex;
                *length = vp->namelen + 2;
        }

        /*Case3:When namelength is greater than or equal to vpnamelen+1*/
        else if( (int)*length >= (int) (vp->namelen+2) )
        {
                len = vp->namelen;
                smTxtbl_node = smTxList_get(&smTxList,(int)name[len],(int)name[len+1],exact);
                if(!smTxtbl_node)
                {
                        return NULL;
                }
                newname[len]  = smTxtbl_node->ifIndex;
                newname[len+1]= smTxtbl_node->MCSTxIndex;
		
                *length = vp->namelen + 2;
        }

        memcpy(name,newname,(*length) * sizeof(oid));
        *var_len = sizeof(int);         /*Default*/
        *write_method = NULL;           /*Default*/


    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11SUPPORTEDMCSTXINDEX:
        return (u_char *) & smTxtbl_node->MCSTxIndex;
    case DOT11SUPPORTEDMCSTXVALUE:
        return (u_char *) & smTxtbl_node->MCSTxValue;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
